      PROGRAM PLBECON
C
C  This program solves the (PL)ate problem using the (B)ounadry
C (E)lement method with (CON)stant elements 
C
      USE MSIMSL
      IMPLICIT REAL*8 (A-H,O-Z)                      
      CHARACTER*15 INPUTFILE,OUTPUTFILE
C
C  Set the maximum dimensions
C
      PARAMETER (N=300)  
      PARAMETER (IN=221) 
	PARAMETER (NB=1)   
	PARAMETER (NC=3)   
	PARAMETER (NFC=0)  
	PARAMETER (NCL=0)
	PARAMETER (NELL=0)   
	PARAMETER (NLL=0)			
	PARAMETER (NLS=0) 		
	PARAMETER (NELS=0)	
	PARAMETER (NPS=0) 	
C	 
C  N  = Number of boundary elements 
C  IN = No of internal points 
C  NC = No of corner points
C  NFC= No of corner points next to free afjacent edges
C  NCL =No of concentrated forces
C  NLL =No of line loads
C  NELL=Total number of points on line loads
C  NLS =No of line supports
C  NELS=Total number of points on line supports
C  NPS =No of points supports 
C
	COMMON D,PN
	COMMON /SURFLOAD/ FX,FY,F0

      DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N),XIN(IN),YIN(IN)
	DIMENSION XC(NC),YC(NC),XFC(NFC),YFC(NFC)
      INTEGER  CCODE(NC)
	DIMENSION XCL(NCL),YCL(NCL),FCL(NCL),FLL(NELL+NLL)
	DIMENSION XLL(NELL+NLL),YLL(NELL+NLL),JL(NELL),KL(NELL)
 	DIMENSION XSL(NELS+NLS),YSL(NELS+NLS),JLS(NELS),KLS(NELS)
	DIMENSION XSM(NELS),YSM(NELS),SL(NELS),UCL(N,NELS)
	DIMENSION XPS(NPS),YPS(NPS),UCP(N,NPS),SP(NPS)
	DIMENSION G(2*N+NFC+NELS+NPS,2*N+NFC+NELS+NPS),FLOADL(2*N)
	DIMENSION H(2*N+NFC+NELS+NPS,2*N+NFC),FLOAD(2*N+NFC+NELS+NPS)
	DIMENSION ANGLE(NFC),ICOR(NFC,2)
	DIMENSION W(N),VN(N),WN(N),WC(NFC),TW(NFC)
	REAL*8    MN(N),LUCL(N,NELS),LUCP(N,NPS),LW(N),LWN(N)
	REAL*8    LWX(IN),LWY(IN),MX(IN),MY(IN),MXY(IN)
	DIMENSION A1(N),A2(N),A3(N),B1(N),B2(N),B3(N)
	DIMENSION C1(NFC),C2(NFC),C3(NFC),FCORN(NC),WCORN(NC)
	DIMENSION HBAR(2*N+NFC,2*N+NFC),GBAR(2*N+NFC,2*N+NFC)
	DIMENSION FBAR(2*N+NFC),CURV(N),WIN(IN),WXX(IN),WXY(IN)
	DIMENSION WX(IN),WY(IN),WYY(IN),QX(IN),QY(IN)

      WRITE (*,'(A)')' Name of the INPUTFILE (max.15 characters)'
      READ  (*,'(A)') INPUTFILE
      WRITE (*,'(A)')' Name of the OUTPUTFILE (max.15 characters)'
      READ  (*,'(A)') OUTPUTFILE
      OPEN (UNIT=1, FILE=INPUTFILE)
      OPEN (UNIT=2, FILE=OUTPUTFILE)
C
C  Read the data from INPUTFILE created by PLDATA
C
	CALL INPUTPL(XL,YL,XM,YM,JN,KN,N,NC,NFC,XC,YC,XFC,YFC
   	&   ,CCODE,NB,ANGLE,ICOR,IN,XIN,YIN,XSL,YSL
     &   ,XSM,YSM,NLS,NELS,JLS,KLS
     &   ,NPS,XPS,YPS,XCL,YCL,NCL,FCL,NELL,NLL,XLL,YLL,JL,KL,FLL,PN
     &   ,EL,HPL,A1,A2,A3,B1,B2,B3,C1,C2,C3,CURV,FX,FY,F0)
	WRITE (*,*) ' *** INPUT FILE OK ***'
	D=EL*Hpl**3/12./(1.-PN**2)	 ! Bending stiffnes
C
C  Compute the G matrix 
C
	CALL GMATRPL(XL,YL,XM,YM,XFC,YFC,JN,KN,N,NFC,XSL,YSL,XSM,YSM
	1        ,JLS,KLS,NELS,NLS,XPS,YPS,NPS,G,UCL,LUCL,UCP,LUCP)
	WRITE (*,*) ' *** GMATRPL OK ***'
C
C  Compute the H matrix 
C
	CALL HMATRPL(XL,YL,XM,YM,XFC,YFC,JN,KN,ICOR,N,NFC,XSM,YSM
	1        ,NELS,XPS,YPS,NPS,angle,H,CURV)
	WRITE (*,*) ' *** HMATRPL OK ***'
C
C  Compute the Hbar and Gbar matrices
C
	CALL HGBARMATR(N,NFC,A1,A2,A3,B1,B2,B3,C1,C2,C3,HBAR,GBAR
	1           ,FBAR)
	WRITE (*,*) ' *** HGBARMATRPL OK ***'
C
C Compute surface, line and point loads  
C
     	CALL FLOADPL(XL,YL,XM,YM,JN,KN,N,NFC,XFC,YFC,NELS,XSM,YSM
     #          ,XPS,YPS,NPS,XLL,YLL,JL,KL,NLL,NELL,FLL
     #          ,XCL,YCL,NCL,FCL,FLOAD,FLOADL)
	WRITE (*,*) ' *** FLOADPL OK ***'
C
C   Solve the system of equations	and computes the unknown boundary quantities
C
	CALL SOLVEQPL(N,NFC,NELS,NPS,H,G,Fload,HBAR,GBAR,FBAR
	&  ,W,WC,WN,VN,MN,SL,SP,TW)

	WRITE (*,*) ' *** SOLVEQPL OK ***'
C
C   Compute Lw and Lwn
C
	CALL LWLWN(N,XL,YL,JN,KN,XM,YM,W,WN,FLOADL,NELS,UCL
	1        ,LUCL,NPS,UCP,LUCP,SL,SP,LW,LWN)

	WRITE (*,*) ' *** LWLWN OK ***'
C
C   Compute w,wx,wy,wxx,wyy,wxy,Lwx,Lwy at the IN internal points
C
	CALL WINTERPL(N,XL,YL,XM,YM,JN,KN,XIN,YIN,IN,XSL,YSL,JLS,KLS
	1 ,NELS,NLS,XPS,YPS,NPS,XLL,YLL,JL,KL,NELL,NLL,FLL,XCl,YCl,NCL
     1  ,FCl,W,WN,LW,LWN,SL,SP,WIN,WX,WY,WXX,WYY,WXY,LWX,LWY)

	WRITE (*,*) ' *** WINTERPL OK ***'
C
C   Compute bending moments and shear forces at IN internal points 
C
	CALL STRESSPL(IN,WXX,WYY,WXY,LWX,LWY,MX,MY,MXY,QX,QY)
	WRITE (*,*) ' *** STRESSPL OK ***'
C
C   Compute the corner forces 
C
      CALL CORNERPL(WC,TW,XM,YM,XL,YL,XC,YC,JN,KN,CCODE,WN,N,NFC,NC
     1    ,FCORN,WCORN)
	WRITE (*,*) ' *** CORNERPL OK ***'
C
C   Print the results in the OUTPUTFILE
C
	CALL OUTPUTPL(XM,YM,W,WN,XC,YC,WCORN,FCORN,VN,MN,XIN,YIN
     1      ,WIN,WX,WY,MX,MY,MXY,QX,QY,N,IN,NC,SL,XSM,YSM,NELS
     1      ,SP,XPS,YPS,NPS)
	WRITE (*,*) ' *** RESULTS ARE PRINTED IN OUTPUT FILE ***'

      END
C
C====================================================================
C
	SUBROUTINE 	INPUTPL(XL,YL,XM,YM,JN,KN,N,NC,NFC,XC,YC,XFC,YFC
	&   ,CCODE,NB,ANGLE,ICOR,IN,XIN,YIN,XSL,YSL
     &   ,XSM,YSM,NLS,NELS,JLS,KLS
     &   ,NPS,XPS,YPS,XCL,YCL,NCL,FCL,NELL,NLL,XLL,YLL,JL,KL,FLL,PN
     &   ,EL,H,A1,A2,A3,B1,B2,B3,C1,C2,C3,CURV,FX,FY,F0)
C
C   This subroutine reads the data from the input file and writes 
C   them in the output file
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N),XIN(IN),YIN(IN)
	DIMENSION XC(NC),YC(NC),XFC(NFC),YFC(NFC),NL(NB),ICOR(NFC,2)
	DIMENSION DL(N),ANGLE(NFC)
	INTEGER  CCODE(NC)
	DIMENSION XSL(NELS+NLS),YSL(NELS+NLS),NBL(NLS),JLS(NELS)
	DIMENSION XPS(NPS),YPS(NPS),XSM(NELS),YSM(NELS),KLS(NELS)
	DIMENSION XCL(NCL),YCL(NCL),FCL(NCL),NML(NLL),XLM(NELL),YLM(NELL)
 	DIMENSION XLL(NELL+NLL),YLL(NELL+NLL),JL(NELL),KL(NELL)
	DIMENSION A1(N),A2(N),A3(N),B1(N),B2(N),B3(N),FLL(NELL+NLL)
 	DIMENSION C1(NFC),C2(NFC),C3(NFC),CURV(N)
      CHARACTER*80 NAME,TITLE

      WRITE(2,10)
  10  FORMAT('',76('*'))
C
C  Read user's name 
C
      READ(1,'(A)') NAME
      WRITE(2,'(A)') NAME
C
C  Read the title of the program
C
      READ(1,'(A)')TITLE
      WRITE(2,'(A)')TITLE
C
C  Read the elastic constants and thickness of plate 
C
	READ (1,*) EL,PN,H
      WRITE(2,20) EL,PN,H
   20 FORMAT(/2X,'ELASTIC CONSTANTS :',2X,'ELASTIC MODULUS =',E10.4,
     1    2X,'POISSON RATIO =',F5.2/,2X,'PLATE THICKNESS=',F5.2,/)
C
C  Read the number of the last element of each boundary
C
	WRITE (2,*) ' NUMBER OF BOUNDARIES ',NB
	DO I=1,NB
	  READ (1,*) NL(I)
			IF (I.EQ.1) THEN
				WRITE (2,50) I,NL(I)
			ELSE
				WRITE (2,50) I,NL(I)-NL(I-1)
			ENDIF
	ENDDO
   50 FORMAT(2X,'  BOUNDARY :',I3,'      ELEMENTS :',I4) 
	WRITE (2,100) N
  100 FORMAT(2X,'TOTAL No OF BOUNDARY ELEMENTS :',I4) 
	K=1
	DO I=1,N
 		IF (I.EQ.NL(K)) THEN
			IF (K.EQ.1) NODF=1
			IF (K.GT.1) NODF=NL(K-1)+1
			JN(I)=I
			KN(I)=NODF
			K=K+1
		ELSE
			JN(I)=I
 			KN(I)=I+1
		ENDIF
	ENDDO
C
C  Read the coordinates of extreme points of the boundary elements 
C
      DO I=1,N
		READ(1,*) XL(I),YL(I)
	ENDDO
C
C  Compute the coordinates of the midpoints of the boundary elements
C
	DO I=1,N
		XM(I)=( XL(KN(I))+XL(JN(I)) )/2.
		YM(I)=( YL(KN(I))+YL(JN(I)) )/2.
 		DL(I)=SQRT((XL(KN(I))-XL(JN(I)))**2+(YL(KN(I))-YL(JN(I)))**2)
	ENDDO
C
C  Write the coordinates of the midpoints in the output file
C
       WRITE(2,150)
  150 FORMAT(/2X,'COORDINATES OF THE MIDPOINTS OF THE BOUNDARY ELEMENTS'
     1        ,//2X,'POINT',9X,'XM',15X,'YM')
 	DO I=1,N
 		WRITE(2,200) I,XM(I),YM(I)
      ENDDO
  200 FORMAT(2X,I5,3(3X,E14.5))
C
C--------------------- CORNER POINTS --------------------------------
C
C  Read the coordinates of the corner points 
C  XC, YC   Coordinates of all corner points
C
	WRITE(2,250)
  250 FORMAT(/2X,'CORNER POINTS',//,2X,'CORNER',6X,'XC',8X,'YC',7X,
     1  'KNOWN VALUE')
	
      K=0
	DO I=1,NC
		READ (1,*) CCODE(I),XC(I),YC(I),W,SP
		IF (CCODE(I).EQ.1) THEN
			K=K+1
			XFC(K)=XC(I)
	  	YFC(K)=YC(I)
			C1(K)=1.
			C2(K)=0.
			C3(K)=W
		  WRITE (2,260) I,XC(I),YC(I),W
		ELSEIF (CCODE(I).EQ.2) THEN
			K=K+1
			XFC(K)=XC(I)
			YFC(K)=YC(I)
			C1(K)=SP
			C2(K)=1.
			C3(K)=W
			WRITE (2,270) I,XC(I),YC(I),W,SP
		ELSE
			WRITE (2,280) I,XC(I),YC(I)
		ENDIF
	ENDDO
  260 FORMAT(2X,I2,2X,2(3X,E10.5),X,'DISPLACEMENT=',E10.3)
  270 FORMAT(2X,I2,2X,2(3X,E10.5),X,'FORCE=',E10.3,3X,
     1     'ELASTIC SUPPORT KT=',E10.3)
  280 FORMAT(2X,I2,2X,2(3X,E10.5),20X,'CORNER NEXT TO SUPPORTED EDGES')
C
C   Read the boundary conditions of the plate
C
	WRITE(2,170)
  170 FORMAT(/2X,'BOUNDARY CONDITIONS '
     1   ,//2X,'ELEMENT',3X,'A1',8X,'A2',9X,'A3',9X,'B1',9X,'B2'
     1   ,10X,'B3')

      DO I=1,N
		READ (1,*) A1(I),A2(I),A3(I),B1(I),B2(I),B3(I),CURV(I)
		WRITE (2,180) I,A1(I),A2(I),A3(I),B1(I),B2(I),B3(I)
	ENDDO
  180 FORMAT(2X,I5,6(3X,E8.3))

C
C  ICOR(NFC,2): The number of the element that is after corner j
C  ICOR(NFC,1): The number of the element that is before corner j
C
	PI=ACOS(-1.)
	DO J=1,NFC
		DO I=1,N
			R1=DSQRT((XL(KN(I))-XFC(J))**2+(YL(KN(I))-YFC(J))**2)
			R2=DSQRT((XL(JN(I))-XFC(J))**2+(YL(JN(I))-YFC(J))**2)
			IF (R1.LT.0.0001) THEN 
				ICOR(J,1)=I
				DX1=XL(JN(I))-XL(KN(I))
				DY1=YL(JN(I))-YL(KN(I))
				S1=DSQRT(DX1**2+DY1**2)
			ELSEIF (R2.LT.0.0001) THEN
				ICOR(J,2)=I
				DX2=XL(KN(I))-XL(JN(I))
				DY2=YL(KN(I))-YL(JN(I))
				S2=DSQRT(DX2**2+DY2**2)
			ENDIF
		ENDDO
		COSF=(DY1*DY2+DX1*DX2)/s1/s2
		PR=DX1*DY2-DX2*DY1
		F=DACOS(COSF)
		IF (PR.GT.0) THEN
			ANGLE(J)=2.*PI-F
		ELSE
			ANGLE(J)=F
		ENDIF
		WRITE (*,*) cosf,angle(j)
	ENDDO
C
C--------------------- INTERNAL SUPPORTS ----------------------------
C
C  LINE SUPPORTS
C
	IF (NLS.GT.0) THEN
	WRITE (2,350) NLS
  350 FORMAT(/2X,'No OF LINE SUPPORTS :',I2)

      DO I=1,NLS
		READ (1,*) NBL(I)
		IF (I.EQ.1) THEN
			WRITE (2,400) I,NBL(I)
		ELSE
			WRITE (2,400) I,NBL(I)-NBL(I-1)
	 		ENDIF
 	ENDDO

  400 FORMAT(2X,'  LINE SUPPORT :',I3,'    ELEMENTS :',I4) 
	WRITE (2,450) NBL(NLS)
  450 FORMAT(2X,'TOTAL ELEMENTS ON LINE SUPPORTS :',I4) 

	DO I=1,NELS+NLS
		READ (1,*) XSL(I),YSL(I)
	ENDDO
C
C JLS	 element I starts with node JLS(I)
C KLS	 element I ends   with node KLS(I)
C
	K=1
	DO I=1,NELS
		IF (I.EQ.NBL(K)+1) K=K+1
		JLS(I)=I+K-1
		KLS(I)=I+1+K-1
	ENDDO
	DO I=1,NELS
		XSM(I)=( XSL( JLS(I) ) + XSL( KLS(I) ) )/2.
		YSM(I)=( YSL( JLS(I) ) + YSL( KLS(I) ) )/2.
	ENDDO
	ENDIF
C
C  POINT SUPPORTS
C
	IF (NPS.GT.0) THEN
	WRITE (2,500) NPS
  500 FORMAT(/2X,'No OF POINT SUPPORTS :',I2)
	DO I=1,NPS
		READ (1,*) XPS(I),YPS(I)
	ENDDO
	ENDIF
C---------------- LOADS ---------------------------------------------
C
C  SURFACE LOADS
C
	READ (1,*) FX,FY,F0
	WRITE (2,520) FX,FY,F0
  520 FORMAT(/2X,'SURFACE LOAD=',E10.3,'*X+',E10.3,'*Y+',E10.3)
C
C  LINE LOADS
C
	IF (NLL.GT.0) THEN
	WRITE (2,550) NLS
  550 FORMAT(/2X,'No OF LINE LOADS :',I2)

	DO I=1,NLL
		READ (1,*) NML(I)
		IF (I.EQ.1) THEN
	 			WRITE (2,600) I,NML(I)
 		ELSE
				WRITE (2,600) I,NML(I)-NML(I-1)
	 ENDIF
 	ENDDO

  600 FORMAT(2X,'  LINE LOAD :',I3,'    ELEMENTS :',I4) 
	WRITE (2,650) NML(NLL)
  650 FORMAT(2X,'TOTAL ELEMENTS ON LINE LOADS :',I4) 
C
C  Read the coordinates of the end points and the value of the load of 
C  the elements on line loads 
C
	DO I=1,NELL+NLL
		READ (1,*) XLL(I),YLL(I),FLL(I)
	ENDDO
C  JLL	 element I starts with node JLS(I)
C  KLL	 element I ends   with node KLS(I)
	K=1
	DO I=1,NELL
		IF (I.EQ.NML(K)+1) K=K+1
		JL(I)=I+K-1
		KL(I)=I+1+K-1
	ENDDO
	DO I=1,NELL
		XLM(I)=( XLL( JL(I) ) + XLL( KL(I) ) )/2.
		YLM(I)=( YLL( JL(I) ) + YLL( KL(I) ) )/2.
	ENDDO
	ENDIF
C
C  Read the coordinates of the concentrated force
C
	IF (NCL.GT.0) THEN
	WRITE (2,700) NCL
  700 FORMAT(/2X,'No OF POINT LOADS :',I2)

      DO I=1,NCL
		READ (1,*) XCL(I),YCL(I),FCL(I)
	ENDDO
	ENDIF
C
C--------------------------------------------------------------------
C
C  Read the coordinates of the internal points
C
	DO I=1,IN
		READ (1,*) XIN(I),YIN(I)
	ENDDO
	CLOSE (1)
	RETURN
	END

C
C====================================================================
C
 	SUBROUTINE GMATRPL(XL,YL,XM,YM,XFC,YFC,JN,KN,N,NFC,XSL,YSL
	1 ,XSM,YSM ,JLS,KLS,NELS,NLS,XPS,YPS,NPS,G,UCL,LUCL,UCP,LUCP)
C
C This subroutine computes the elements of G matrix
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N),XFC(NFC),YFC(NFC)
 	DIMENSION XSL(NELS+NLS),YSL(NELS+NLS),JLS(NELS),KLS(NELS)
      DIMENSION XSM(NELS),YSM(NELS),USL(NELS,NELS)
	DIMENSION XPS(NPS),YPS(NPS),ULP(NPS,NELS),UPL(NELS,NPS)
	DIMENSION UCL(N,NELS),U1CL(N,NELS),UCCL(NFC,NELS)
	DIMENSION UCP(N,NPS),U1CP(N,NPS),UCCP(NFC,NPS),UPP(NPS,NPS)
	REAL*8 LUCL(N,NELS),LUCP(N,NPS)
	DIMENSION G(2*N+NFC+NELS+NPS,2*N+NFC+NELS+NPS)

	COMMON D,PN

	PI=ACOS(-1.)
	G=0.
      DO I=1,N
		X0=XM(I)
		Y0=YM(I)
		XA1=XL(JN(I))
		YA1=YL(JN(I))
		XA2=XL(KN(I))
		YA2=YL(KN(I))
		SAL=SQRT((XA1-XA2)**2+(YA1-YA2)**2)
		AAX=(XA2-XA1)/2.
 		AAY=(YA2-YA1)/2.
		ENAX=2.*AAY/SAL
 		ENAY=-2.*AAX/SAL
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			SL=DSQRT((X1-X2)**2+(Y1-Y2)**2)
			IF (I.EQ.J) THEN 
				G(I,J)=SL**3/96./PI/D*(DLOG(SL/2.)-1./3.)
				G(I,J+N+NFC)=0.
				G(I+N+NFC,J)=0
				G(I+N+NFC,J+N+NFC)=-(SL/8./D/PI-SL/4./D/PI*DLOG(SL/2.))
			ELSE
				CALL RLINTG(X0,Y0,X1,Y1,X2,Y2,ENAX,ENAY,U,UN,U1,U1N)
				G(I,J)=U
				G(I,J+N+NFC)=-UN
				G(I+N+NFC,J)=U1
				G(I+N+NFC,J+N+NFC)=-U1N
			ENDIF
		ENDDO
		
		IF (NFC.GT.0) THEN
			DO J=1,NFC
 				DX=XFC(J)-X0
				DY=YFC(J)-Y0
 				R=DSQRT(DX**2+DY**2)
				COSA=DX/R
				SINA=DY/R
				RAN=-COSA*ENAX-SINA*ENAY
				RAT=COSA*ENAY-SINA*ENAX
				G(I,J+N)=-1./8./PI/D*R**2*DLOG(R)
				G(I+N+NFC,J+N)=-1./8./PI/D*R*RAN*(1.+2.*DLOG(R))
			ENDDO
		ENDIF
	ENDDO

	IF (NFC.gt.0) then
		DO I=1,NFC
			X0=XFC(I)
			Y0=YFC(I)
			DO J=1,N
				X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
				Y1=YL(JN(J))
				X2=XL(KN(J))
				Y2=YL(KN(J))
				SL=DSQRT((X1-X2)**2+(Y1-Y2)**2)
				R1=0.
 				R2=0.
  				R1=SQRT((X0-X1)**2+(Y0-Y1)**2)
				R2=SQRT((X0-X2)**2+(Y0-Y2)**2)
				IF (R1.LT.0.00001.OR.R2.LT.0.00001) THEN
					G(I+N,J)=SL**3/72./PI/D*(3.*DLOG(SL)-1.)
					G(I+N,J+N+NFC)=0.
				ELSE
					CALL RLINTGC(X0,Y0,X1,Y1,X2,Y2,UC,UCN)
					G(I+N,J)=UC
					G(I+N,J+N+NFC)=-UCN
				ENDIF
			ENDDO
			
			DO J=1,NFC
 				DX=XFC(J)-X0
				DY=YFC(J)-Y0
 				R=DSQRT(DX**2+DY**2)
				IF (R.GT.0.0001) THEN
					G(I+N,J+N)=-1./8./PI/D*R**2*DLOG(R)
				ENDIF
			ENDDO
		ENDDO
	ENDIF 

	IF (NELS.GT.0) THEN

	DO I=1,NELS
		X0=XSM(I)
		Y0=YSM(I)
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			SL=DSQRT((X1-X2)**2+(Y1-Y2)**2)
			R1=0.
 			R2=0.
  			R1=SQRT((X0-X1)**2+(Y0-Y1)**2)
			R2=SQRT((X0-X2)**2+(Y0-Y2)**2)
			CALL RLINTGC(X0,Y0,X1,Y1,X2,Y2,UC,UCN)
			G(I+2*N+NFC,J)=UC
			G(I+2*N+NFC,J+N+NFC)=-UCN
		ENDDO
		DO J=1,NFC
  			DX=XFC(J)-X0
			DY=YFC(J)-Y0
 			R=DSQRT(DX**2+DY**2)
			G(I+2*N+NFC,J+N)=-1./8./PI/D*R**2*DLOG(R)
		ENDDO
	ENDDO

	CALL UINLMATR(XSL,YSL,JLS,KLS,NELS,NLS,XSM,YSM,NELS,USL)
	CALL UBLMATR(XL,YL,XM,YM,JN,KN,N,XFC,YFC,NFC,XSL,YSL
	1          ,JLS,KLS,NLS,NELS,UCL,U1CL,UCCL,LUCL)

	DO J=1,NELS
		DO I=1,N
			G(I,J+2*N+NFC)=UCL(I,J)
			G(I+N+NFC,J+2*N+NFC)=U1CL(I,J)
		ENDDO
		DO I=1,NFC
			G(I+N,J+2*N+NFC)=UCCL(I,J)
		ENDDO
  		DO I=1,NELS
			G(I+2*N+NFC,J+2*N+NFC)=USL(I,J)
		ENDDO
	ENDDO
	ENDIF

	IF (NPS.GT.0) THEN
	DO I=1,NPS
		X0=XPS(I)
		Y0=YPS(I)
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			SL=DSQRT((X1-X2)**2+(Y1-Y2)**2)
			R1=0.
 			R2=0.
  			R1=SQRT((X0-X1)**2+(Y0-Y1)**2)
			R2=SQRT((X0-X2)**2+(Y0-Y2)**2)
			CALL RLINTGC(X0,Y0,X1,Y1,X2,Y2,UC,UCN)
			G(I+2*N+NFC+NELS,J)=UC
			G(I+2*N+NFC+NELS,J+N+NFC)=-UCN
		ENDDO
		DO J=1,NFC
   			DX=XFC(J)-X0
			DY=YFC(J)-Y0
 			R=DSQRT(DX**2+DY**2)
			G(I+2*N+NFC+NELS,J+N)=-1./8./PI/D*R**2*DLOG(R)
		ENDDO
	ENDDO

	CALL UINLMATR(XSL,YSL,JLS,KLS,NELS,NLS,XPS,YPS,NPS,ULP)
	CALL UBPMATR(XL,YL,XM,YM,JN,KN,N,XFC,YFC,NFC,XPS,YPS,NPS
	1         ,UCp,U1Cp,UCCp,LUCP)
	CALL UINPMATR(XPS,YPS,NPS,XSM,YSM,NELS,UPL)
	CALL UINPMATR(XPS,YPS,NPS,XPS,YPS,NPS,UPP)

	DO I=1,NPS
		DO J=1,NELS
			G(I+2*N+NFC+NELS,J+2*N+NFC)=ULP(I,J)
		ENDDO
		DO J=1,NPS
			G(I+2*N+NFC+NELS,J+2*N+NFC+NELS)=UPP(I,J)
		ENDDO
	ENDDO

	DO J=1,NPS
		DO I=1,N
			G(I,J+2*N+NFC+NELS)=UCP(I,J)
			G(I+N+NFC,J+2*N+NFC+NELS)=U1CP(I,J)
		ENDDO
		DO I=1,NFC
			G(I+N,J+2*N+NFC+NELS)=UCCP(I,J)
		ENDDO
		DO I=1,NELS
			G(I+2*N+NFC,J+2*N+NFC+NELS)=UPL(I,J)
		ENDDO
	ENDDO
	ENDIF

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE RLINTG(X0,Y0,X1,Y1,X2,Y2,ENAX,ENAY,U,UN,U1,U1N)
C
C  This subroutine computes the off-diagonal elements of the 
C  matrix G when the source point is at a smooth point
C
C  R= The distance of the point O to the Gauss integration point 
C      on the boundary element
C
C  WG= The weights of the Gauss integration
C
C  XI= The coordinates of the Gauss integration points in the 
C      interval [-1,1]
C
C  XC,YC=The global coordinates of the Gauss integration points
C
      IMPLICIT REAL*8 (A-H,O-Z)
	COMMON D,PN

      DIMENSION XI(4),WG(4)
      DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
      DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

      PI=ACOS(-1.)

      AX=(X2-X1)/2.
      AY=(Y2-Y1)/2.
      BX=(X2+X1)/2.
      BY=(Y2+Y1)/2.
      SL=DSQRT(AX**2+AY**2)
      ENX=AY/SL
      ENY=-AX/SL

C
C  Compute the line integral with 4 point Gauss integration
C
	U=0.
	UN=0.
	U1=0.
	U1N=0.

      DO I=1,4
		XC=0.
		YC=0.
		XC=AX*XI(I)+BX
 		YC=AY*XI(I)+BY
 		R=0
		DX=XC-X0
 		DY=YC-Y0
		R=dSQRT(DX**2+DY**2)
		COSA=DX/R
		SINA=DY/R
		RN=COSA*ENX+SINA*ENY
		RT=SINA*ENX-COSA*ENY
		RAN=-COSA*ENAX-SINA*ENAY
		RAT=COSA*ENAY-SINA*ENAX
		UN=UN+1./8./D/PI*R*RN*(2.*DLOG(R)+1.)*WG(I)*sl
 		U=U+1./8./D/PI*R**2*DLOG(R)*WG(I)*sl
		U1N=U1N+ 1./8./D/PI*(2.*(RN*RAN+RT*RAT)*DLOG(R)
	1       +3.*RN*RAN+RT*RAT)*WG(I)*sl
 		U1=U1+ 1./8./D/PI*R*RAN*(2.*DLOG(R)+1.)*WG(I)*sl
 	ENDDO

      RETURN
      END
C
C====================================================================
C

	SUBROUTINE RLINTGC(X0,Y0,X1,Y1,X2,Y2,UC,UCN)
C
C  This subroutine computes the off-diagonal elements of the 
C  matrix G when the source point is at a corner point
C
C  R= The distance of the point O to the Gauss integration point 
C      on the boundary element
C
C  WG= The weights of the Gauss integration
C
C  XI= The coordinates of the Gauss integration points in the 
C      interval [-1,1]
C
C  XC,YC=The global coordinates of the Gauss integration points
C
      IMPLICIT REAL*8 (A-H,O-Z)
	COMMON D,PN

      DIMENSION XI(4),WG(4)
      DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
      DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

      PI=ACOS(-1.)

      AX=(X2-X1)/2.
      AY=(Y2-Y1)/2.
      BX=(X2+X1)/2.
      BY=(Y2+Y1)/2.
      SL=DSQRT(AX**2+AY**2)
      ENX=AY/SL
      ENY=-AX/SL

C
C  Compute the line integral with 4 point Gauss integration
C
	UC=0.
	UCN=0.
      DO I=1,4
		XC=0.
		YC=0.
		XC=AX*XI(I)+BX
 		YC=AY*XI(I)+BY
 		R=0
		DX=XC-X0
 		DY=YC-Y0
		R=SQRT(DX**2+DY**2)
		COSA=DX/R
		SINA=DY/R
		RN=COSA*ENX+SINA*ENY
		RT=SINA*ENX-COSA*ENY
		UCN=UCN+1./8./D/PI*SL*R*RN*(2.*DLOG(R)+1.)*WG(I)
 		UC=UC+1./8./D/PI*SL*R**2*DLOG(R)*WG(I)
 	ENDDO

      RETURN
      END
C
C====================================================================
C
 	SUBROUTINE HMATRPL(XL,YL,XM,YM,XC,YC,JN,KN,ICOR,N,NFC,XSM,YSM
	1        ,NELS,XPS,YPS,NPS,ANGLE,H,CURV)
C
C This subroutine computes the elements of H matrix
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N),XC(NFC),YC(NFC)
 	DIMENSION XSM(NELS),YSM(NELS),XPS(NPS),YPS(NPS),CURV(n)
	DIMENSION H(2*N+NFC+NELS+NPS,2*N+NFC),ICOR(NFC,2),ANGLE(NFC)

	COMMON D,PN

	PI=ACOS(-1.)
	H=0.

      DO I=1,N
 		X0=XM(I)
		Y0=YM(I)

		XA1=XL(JN(I))
		YA1=YL(JN(I))

		XA2=XL(KN(I))
		YA2=YL(KN(I))

		SAL=SQRT((XA1-XA2)**2+(YA1-YA2)**2)
		AAX=(XA2-XA1)/2.
 		AAY=(YA2-YA1)/2.

		ENAX=2.*AAY/SAL
 		ENAY=-2.*AAX/SAL

		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			SL=DSQRT((X1-X2)**2+(Y1-Y2)**2)
			IF (I.EQ.J) THEN 
				H(I,J)=0.5+(1.-pn)/4./pi*CURV(j)*sal    
				H(I,J+N+NFC)=-(-(1.+PN)/4./PI*SL*DLOG(SL/2.)
	& 				+(1.-PN)/8./PI*SL)
				H(I+N+NFC,J)=-(1.+PN)/PI/SL
				H(I+N+NFC,J+N+NFC)=-(-0.5)
			ELSE
	CALL RLINTH(X0,Y0,X1,Y1,X2,Y2,ENAX,ENAY,UV,UM,U1V,U1M,CURV(j))
				H(I,J)=UV
				H(I,J+N+NFC)=-UM
				H(I+N+NFC,J)=U1V
				H(I+N+NFC,J+N+NFC)=-U1M
			ENDIF
		ENDDO

		IF (NFC.GT.0) then
			DO J=1,NFC
				NEL1=ICOR(J,1)
  				X1=XL(JN(NEL1))
				Y1=YL(JN(NEL1))
				X2=XL(KN(NEL1))
				Y2=YL(KN(NEL1))
			 	NEL2=ICOR(J,2)
				X3=XL(JN(NEL2))
				Y3=YL(JN(NEL2))
				X4=XL(KN(NEL2))
				Y4=YL(KN(NEL2))
			 	AX1=X2-X1
  				AY1=Y2-Y1
				AL1=SQRT(AX1**2+AY1**2)
				ENX1=AY1/AL1
				ENY1=-AX1/AL1
			 	AX2=X4-X3
		  		AY2=Y4-Y3
				AL2=SQRT(AX2**2+AY2**2)
				ENX2=AY2/AL2
				ENY2=-AX2/AL2

			 	DX=XC(J)-X0
				DY=YC(J)-Y0
 				R=DSQRT(DX**2+DY**2)
				COSA=DX/R
				SINA=DY/R
				RN1=COSA*ENX1+SINA*ENY1
				RT1=SINA*ENX1-COSA*ENY1
				RN2=COSA*ENX2+SINA*ENY2
			 	RT2=SINA*ENX2-COSA*ENY2
				RAN=-COSA*ENAX-SINA*ENAY
				RAT=COSA*ENAY-SINA*ENAX

				H(I,J+N)=-(1.-PN)/4./PI*(RN2*RT2-RN1*RT1)
				H(I+N+NFC,J+N)=-((1.-PN)/4./PI/R*((RT2**2-RN2**2)
	1				-(RT1**2-RN1**2))*RAT)
			ENDDO
		ENDIF
	ENDDO



	IF (NFC.GT.0) then
		DO I=1,NFC
			X0=XC(I)
			Y0=YC(I)
			DO J=1,N
				X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
				Y1=YL(JN(J))
				X2=XL(KN(J))
				Y2=YL(KN(J))
				SL=DSQRT((X1-X2)**2+(Y1-Y2)**2)	
				R1=0.
			 	R2=0.
  				R1=SQRT((X0-X1)**2+(Y0-Y1)**2)
				R2=SQRT((X0-X2)**2+(Y0-Y2)**2)
 				IF (R1.LT.0.00001.OR.R2.LT.0.00001) THEN
					H(I+N,J)=0.
					H(I+N,J+N+NFC)=-(-(1.+PN)*SL*DLOG(SL)/4./PI
	1					+(1.-PN)*SL/8./PI)
				ELSE
	CALL RLINTHC(X0,Y0,X1,Y1,X2,Y2,UVC,UMC,CURV(j))
					H(I+N,J)=UVC
					H(I+N,J+N+NFC)=-UMC
				ENDIF
			ENDDO
			DO J=1,NFC
 				DX=XC(J)-X0
 				DY=YC(J)-Y0
 				R=DSQRT(DX**2+DY**2)
				IF (R.GT.0.0001) THEN
					NEL1=ICOR(J,1)
  					X1=XL(JN(NEL1))
					Y1=YL(JN(NEL1))
					X2=XL(KN(NEL1))
					Y2=YL(KN(NEL1))
				 	NEL2=ICOR(J,2)
					X3=XL(JN(NEL2))
					Y3=YL(JN(NEL2))
					X4=XL(KN(NEL2))
					Y4=YL(KN(NEL2))
				 	AX1=X2-X1
  					AY1=Y2-Y1
					AL1=SQRT(AX1**2+AY1**2)
					ENX1=AY1/AL1
					ENY1=-AX1/AL1
 					AX2=X4-X3
  					AY2=Y4-Y3
					AL2=SQRT(AX2**2+AY2**2)
					ENX2=AY2/AL2
					ENY2=-AX2/AL2
					COSA=DX/R
					SINA=DY/R
					RN1=COSA*ENX1+SINA*ENY1
					RT1=SINA*ENX1-COSA*ENY1
					RN2=COSA*ENX2+SINA*ENY2
 					RT2=SINA*ENX2-COSA*ENY2
					H(I+N,J+N)=-(1.-PN)/4./PI*(RN2*RT2-RN1*RT1)
				ELSE
					H(I+N,J+N)=ANGLE(I)/2./PI
				ENDIF
			ENDDO
		ENDDO
	ENDIF

	IF (NELS.GT.0) then

	DO I=1,NELS
		X0=XSM(I)
		Y0=YSM(I)
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			SL=DSQRT((X1-X2)**2+(Y1-Y2)**2)
			R1=0.
			R2=0.
  			R1=SQRT((X0-X1)**2+(Y0-Y1)**2)
			R2=SQRT((X0-X2)**2+(Y0-Y2)**2)
	CALL RLINTHC(X0,Y0,X1,Y1,X2,Y2,UVC,UMC,CURV(j))
			H(I+2*N+NFC,J)=UVC
			H(I+2*N+NFC,J+N+NFC)=-UMC
		ENDDO
	
		DO J=1,NFC
 			DX=XC(J)-X0
 			DY=YC(J)-Y0
 			R=DSQRT(DX**2+DY**2)
			NEL1=ICOR(J,1)
  			X1=XL(JN(NEL1))
			Y1=YL(JN(NEL1))
			X2=XL(KN(NEL1))
			Y2=YL(KN(NEL1))
		 	NEL2=ICOR(J,2)
			X3=XL(JN(NEL2))
			Y3=YL(JN(NEL2))
			X4=XL(KN(NEL2))
			Y4=YL(KN(NEL2))
		 	AX1=X2-X1
  			AY1=Y2-Y1
			AL1=SQRT(AX1**2+AY1**2)
			ENX1=AY1/AL1
			ENY1=-AX1/AL1
		 	AX2=X4-X3
  			AY2=Y4-Y3
			AL2=SQRT(AX2**2+AY2**2)
			ENX2=AY2/AL2
			ENY2=-AX2/AL2
			COSA=DX/R
			SINA=DY/R
			RN1=COSA*ENX1+SINA*ENY1
			RT1=SINA*ENX1-COSA*ENY1
			RN2=COSA*ENX2+SINA*ENY2
 			RT2=SINA*ENX2-COSA*ENY2
			H(I+2*N+NFC,J+N)=-(1.-PN)/4./PI*(RN2*RT2-RN1*RT1)
		ENDDO
	ENDDO

	ENDIF

	IF (NPS.GT.0) THEN

		DO I=1,NPS
			X0=XPS(I)
			Y0=YPS(I)
			DO J=1,N
				X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
 				Y1=YL(JN(J))
 				X2=XL(KN(J))
 				Y2=YL(KN(J))
				SL=DSQRT((X1-X2)**2+(Y1-Y2)**2)
				R1=0.
 				R2=0.
   				R1=SQRT((X0-X1)**2+(Y0-Y1)**2)
    				R2=SQRT((X0-X2)**2+(Y0-Y2)**2)
  				CALL RLINTHC(X0,Y0,X1,Y1,X2,Y2,UVC,UMC,CURV(j))
				H(I+2*N+NFC+NELS,J)=UVC
				H(I+2*N+NFC+NELS,J+N+NFC)=-UMC
			ENDDO
			DO J=1,NFC
 				DX=XC(J)-X0
 				DY=YC(J)-Y0
 				R=DSQRT(DX**2+DY**2)
				NEL1=ICOR(J,1)
  				X1=XL(JN(NEL1))
				Y1=YL(JN(NEL1))
				X2=XL(KN(NEL1))
				Y2=YL(KN(NEL1))
		 		NEL2=ICOR(J,2)
				X3=XL(JN(NEL2))
				Y3=YL(JN(NEL2))
				X4=XL(KN(NEL2))
				Y4=YL(KN(NEL2))
		 		AX1=X2-X1
  				AY1=Y2-Y1
				AL1=SQRT(AX1**2+AY1**2)
				ENX1=AY1/AL1
				ENY1=-AX1/AL1
		 		AX2=X4-X3
  				AY2=Y4-Y3
				AL2=SQRT(AX2**2+AY2**2)
				ENX2=AY2/AL2
				ENY2=-AX2/AL2
				COSA=DX/R
				SINA=DY/R
				RN1=COSA*ENX1+SINA*ENY1
				RT1=SINA*ENX1-COSA*ENY1
				RN2=COSA*ENX2+SINA*ENY2
 				RT2=SINA*ENX2-COSA*ENY2
				H(I+2*N+NFC+NELS,J+N)=-(1.-PN)/4./PI*(RN2*RT2-RN1*RT1)
			ENDDO
		ENDDO
      ENDIF

	RETURN
	END
C
C====================================================================
C

	SUBROUTINE RLINTH(X0,Y0,X1,Y1,X2,Y2,ENAX,ENAY,UV,UM,U1V,U1M,CURV)
C
C  This subroutine computes the off-diagonal elements of the 
C  matrix H when the source point is at a smooth point
C
C  R= The distance of the point O to the Gauss integration point 
C      on the boundary element
C
C  WG= The weights of the Gauss integration
C
C  XI= The coordinates of the Gauss integration points in the 
C      interval [-1,1]
C
C  XC,YC=The global coordinates of the Gauss integration points
C
      IMPLICIT REAL*8 (A-H,O-Z)
	COMMON D,PN

      DIMENSION XI(4),WG(4)
      DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
      DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

      PI=ACOS(-1.)

      AX=(X2-X1)/2.
      AY=(Y2-Y1)/2.
      BX=(X2+X1)/2.
      BY=(Y2+Y1)/2.
      SL=DSQRT(AX**2+AY**2)
      ENX=AY/SL
      ENY=-AX/SL

C
C  Compute the line integral with 4 point Gauss integration
C
	UV=0.
	UM=0.
	U1V=0.
	U1M=0.

      DO I=1,4
		XC=0.
		YC=0.
		XC=AX*XI(I)+BX
 		YC=AY*XI(I)+BY
 		R=0.
		DX=XC-X0
 		DY=YC-Y0
		R=SQRT(DX**2+DY**2)
		COSA=DX/R
		SINA=DY/R
		RN=COSA*ENX+SINA*ENY
		RT=SINA*ENX-COSA*ENY
		RAN=-COSA*ENAX-SINA*ENAY
		RAT=COSA*ENAY-SINA*ENAX
		UV=UV-1./4./PI/R*SL*(2.*RN+(1.-PN)*(RN-R*CURV)
	1            	*(RN**2-RT**2))*WG(I)
		UM=UM-1./8./PI*SL*(2*(PN+1.)*DLOG(R)+(PN+3.)*RN**2+(1.+3.*PN)
	1	     *RT**2)*WG(I)

		U1V=U1V-1./4./PI/R**2*SL*((3.-PN-2.*(1.-PN)*RT**2)
	1	     *(RT*RAT-RN*RAN)+4.*(1.-PN)*(RN-CURV*r)*rn*RT*RAT)*WG(I)
 		U1M=U1M-1./4./PI/R*SL*((PN+1.)*RAN+2.*(1.-PN)*RN*RT*RAT)*WG(I)
 	ENDDO
	
 
      RETURN
      END

C
C====================================================================
C

	SUBROUTINE RLINTHC(X0,Y0,X1,Y1,X2,Y2,UVC,UMC,CURV)

C
C  This subroutine computes the off-diagonal elements of the 
C  matrix H when the source point is at a corner
C
C  R= The distance of the point O to the Gauss integration point 
C      on the boundary element
C
C  WG= The weights of the Gauss integration
C
C  XI= The coordinates of the Gauss integration points in the 
C      interval [-1,1]
C
C  XC,YC=The global coordinates of the Gauss integration points
C
      IMPLICIT REAL*8 (A-H,O-Z)
	COMMON D,PN

      DIMENSION XI(4),WG(4)
      DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
      DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

      PI=ACOS(-1.)

      AX=(X2-X1)/2.
      AY=(Y2-Y1)/2.
      BX=(X2+X1)/2.
      BY=(Y2+Y1)/2.
      SL=DSQRT(AX**2+AY**2)
      ENX=AY/SL
      ENY=-AX/SL

C
C  Compute the line integral with 4 point Gauss integration
C
	UVC=0.
	UMC=0.

      DO I=1,4
		XC=0.
		YC=0.
		XC=AX*XI(I)+BX
 		YC=AY*XI(I)+BY
 		R=0.
		DX=XC-X0
 		DY=YC-Y0
		R=SQRT(DX**2+DY**2)
		COSA=DX/R
		SINA=DY/R
		RN=COSA*ENX+SINA*ENY
		RT=SINA*ENX-COSA*ENY
		UVC=UVC-1./4./PI/R*SL*(2.*RN+(1.-PN)*(RN-R*CURV)
	1              	*(RN**2-RT**2))*WG(I)
 		UMC=UMC-1./8./PI*SL*(2*(PN+1.)*DLOG(R)+(PN+3.)*RN**2
	&		+(1.+3.*PN)*RT**2)*WG(I)
 	ENDDO

      RETURN
      END
C
C====================================================================
C
 	SUBROUTINE HGBARMATR(N,NFC,A1,A2,A3,B1,B2,B3,C1,C2,C3,HBAR,GBAR
	1           ,FBAR)
C
C  This subroutine produces the matrices Hbar,Gbar of Eq. 2.139 
C
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION HBAR(2*N+NFC,2*N+NFC),GBAR(2*N+NFC,2*N+NFC)
	DIMENSION A1(N),A2(N),A3(N),B1(N),B2(N),B3(N)
  	DIMENSION C1(NFC),C2(NFC),C3(NFC),FBAR(2*N+NFC)

	HBAR=0.
	GBAR=0.
	FBAR=0.

	DO I=1,N
		HBAR(I,I)=A1(I)
		HBAR(I+N+NFC,I+N+NFC)=B1(I)
		GBAR(I,I)=A2(I)
		GBAR(I+N+NFC,I+N+NFC)=B2(I)
		FBAR(I)=A3(I)
		FBAR(I+N+NFC)=B3(I)
	ENDDO
 	DO I=1,NFC
	  HBAR(I+N,I+N)=C1(I)
	  GBAR(I+N,I+N)=C2(I)
	  FBAR(I+N)=C3(I)
	ENDDO

	RETURN
	END
C
C====================================================================
C
 	SUBROUTINE SOLVEQPL(N,NFC,NELS,NPS,H,G,F,HBAR,GBAR,FBAR
	&  ,W,WC,WN,VN,MN,SL,SP,TW)
C
C  This subroutine solves the system of Eq. 2.131 and 2.138
C
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION G(2*N+NFC+NELS+NPS,2*N+NFC+NELS+NPS)
	DIMENSION H(2*N+NFC+NELS+NPS,2*N+NFC),FBAR(2*N+NFC)
	DIMENSION HBAR(2*N+NFC,2*N+NFC),GBAR(2*N+NFC,2*N+NFC)
	DIMENSION A(4*N+2*NFC+NELS+NPS,4*N+2*NFC+NELS+NPS)
	DIMENSION F(2*N+NFC+NELS+NPS),B(4*N+2*NFC+NELS+NPS)
	DIMENSION SL(NELS),SP(NPS),W(N),VN(N),WN(N),WC(NFC),TW(NFC)
	REAL*8    MN(N)

	A=0.
	W=0.
	WN=0.
	WC=0.
	VN=0.
	MN=0.
	B=0.

	DO I=1,2*N+NFC+NPS+NELS
      	DO J=1,2*N+NFC
	  	A(I,J)=H(I,J)
		ENDDO
		DO J=1,2*N+NFC+NPS+NELS
			A(I,J+2*N+NFC)=-G(I,J)
		ENDDO	
		B(I)=F(I)
	ENDDO

	DO I=1,2*N+NFC
		DO J=1,2*N+NFC
			A(I+2*N+NFC+NELS+NPS,J)=HBAR(I,J)
			A(I+2*N+NFC+NELS+NPS,J+2*N+NFC)=GBAR(I,J)
		ENDDO
	  	B(I+2*N+NFC+NELS+NPS)=FBAR(I)
	ENDDO

	CALL LEQS(A,B,4*N+2*NFC+NELS+NPS,LSING)
			 
	IF (LSING.EQ.0) THEN
		WRITE(2,50)
		WRITE (*,50)
      ELSEIF(LSING.EQ.1)THEN
		WRITE(2,70)
		WRITE(*,70)
      ENDIF

  50	FORMAT(/,'',76('*')//2X'The system has been solved regularly'/)
  70  FORMAT(/,'',76('*')//2X'The system is singular'/)

	DO I=1,N
	  W(I)=B(I)
	  WN(I)=B(I+N+NFC)
	  VN(I)=B(I+2*N+NFC)
	  MN(I)=B(I+3*N+2*NFC)
	ENDDO
	DO I=1,NFC
	  WC(I)=B(I+N)
	  TW(I)=B(I+3*N+NFC)
	ENDDO
	DO I=1,NPS
	  SP(I)=B(4*N+2*NFC+NELS+I)
	ENDDO
	DO I=1,NELS
	  SL(I)=B(4*N+2*NFC+I)
	ENDDO

	RETURN
	END
C
C==================================================================
C
      SUBROUTINE LEQS(A,B,N,LSING)
C
C   This subroutine uses Gauss elimination to solve
C   a system of linear equations, [A]{X}={B}, where
C   A : One-dimensional array which contains the occasional row of
C       the two-dimensional array of the coefficients of the unknowns
C   B : One-dimensional array which contains the known coefficients
C   N : Integer denoting the number of the unknowns
C   LSING: Integer taking the values:
C         LSING = 0, if the system has been solved regularly
C         LSING = 1, if the system is singular
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1),B(1)
C
      LSING=0
      JJ=-N
      DO 10 J=1,N
        JY=J+1
        JJ=JJ+N+1
        AMAX=0.0
        IHELP=JJ-J
      DO 20 I=J,N
        IJ=IHELP+I
        IF(ABS(AMAX)-ABS(A(IJ))) 30,20,20
   30      AMAX=A(IJ)
           IMAX=I
   20 CONTINUE
         IF(ABS(AMAX).EQ.0.) THEN
            LSING=1
            RETURN
         END IF
      I1=J+N*(J-2)
      IHELP=IMAX-J
      DO 40 K=J,N
        I1=I1+N
        I2=I1+IHELP
        ATEMP=A(I1)
        A(I1)=A(I2)
        A(I2)=ATEMP
   40 A(I1)=A(I1)/AMAX
      ATEMP=B(IMAX)
      B(IMAX)=B(J)
      B(J)=ATEMP/AMAX
         IF(J-N) 50,70,50
   50       IQS=N*(J-1)
            DO 10 IX=JY,N
              IXJ=IQS+IX
              IHELP=J-IX
              DO 60 JX=JY,N
                IJREF=N*(JX-1)+IX
                JJX=IJREF+IHELP
   60           A(IJREF)=A(IJREF)-(A(IXJ)*A(JJX))
   10 B(IX)=B(IX)-B(J)*A(IXJ)
   70    NY=N-1
      NN=N*N
      DO 80 J=1,NY
        I1=NN-J
        I2=N-J
        I3=N
      DO 80 K=1,J
        B(I2)=B(I2)-A(I1)*B(I3)
        I1=I1-N
   80   I3=I3-1
      RETURN
      END
C
C====================================================================
C

	SUBROUTINE LWLWN(N,XL,YL,JN,KN,XM,YM,WB,WN,FLOAD2D
	1             ,NELS,UCL,LUCL,NPS,UCP,LUCP,SL,SP,LW,LWN)
C
C This subroutine computes the Laplacian of the deflection w and 
C its normal derivative at the boundary
C
	IMPLICIT REAL*8 (A-H,O-Z)
	COMMON D,PN
 	DIMENSION XM(N),YM(N),XL(N),YL(N),JN(N),KN(N),FLOAD2D(2*N)
	DIMENSION UCL(N,NELS),SL(NELS),F2(2*N)
	DIMENSION UCP(N,NPS),SP(NPS)
	REAL*8 LUCP(N,NPS),LUCL(N,NELS),LVN(N,N),LW(N),LWN(N),LV(N,N)
	DIMENSION V(N,N),VN(N,N),WB(N),WN(N)
	DIMENSION F1(N),A(2*N,2*N) 

	CALL KERNLMATR (XL,YL,XM,YM,JN,KN,N,N,V,VN,LV,LVN)

	DO I=1,N
		DO J=1,N
			V(I,J)=D*V(I,J)
			VN(I,J)=D*VN(I,J)
			LV(I,J)=D*LV(I,J)
			LVN(I,J)=D*LVN(I,J)
		ENDDO
	ENDDO

	DO I=1,N
		LVN(I,I)=LVN(I,I)-0.5
	ENDDO

	F1=0.
	F2=0.

	DO I=1,N
		DO J=1,N
			F1(I)=F1(I)+LVN(I,J)*WB(J)-LV(I,J)*WN(J)
		ENDDO
		DO J=1,NELS
			F2(I)=F2(I)+UCL(I,J)*SL(J)
			F2(I+N)=F2(I+N)+LUCL(I,J)*SL(J)
		ENDDO
		DO J=1,NPS
			F2(I)=F2(I)+UCP(I,J)*SP(J)
			F2(I+N)=F2(I+N)+LUCP(I,J)*SP(J)
		ENDDO
	ENDDO

	DO I=1,N
		FLOAD2D(I)=FLOAD2D(I)+F1(I)+F2(I)
		FLOAD2D(I+N)=FLOAD2D(I+N)+F2(I+N)	
		DO J=1,N
			A(I,J)=V(I,J)
			A(I,N+J)=-VN(I,J)
			A(I+N,J)=LV(I,J)
			A(I+N,J+N)=-LVN(I,J)
		ENDDO
	ENDDO

      CALL LEQS(A,FLOAD2D,2*N,LSING)

	DO I=1,N
		LWN(I)=FLOAD2D(I) 
		LW(I)=FLOAD2D(I+N)
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE KERNLMATR(XL,YL,XIN,YIN,JN,KN,N,IN,V,VN,LV,LVN)
C
C This subroutine computes the matrices of the boundary integrals of 
C Eq.2.119-2.120 
C	           
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION XL(N),YL(N),XIN(IN),YIN(IN),JN(N),KN(N)
	DIMENSION V(IN,N),VN(IN,N)
	REAL*8 LV(IN,N),LVN(IN,N)
	COMMON D,PN
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)

	V=0.
	VN=0.
	LV=0.
	LVN=0.
 
      DO I=1,IN
 		X0=XIN(I)
		Y0=YIN(I)
		DO J=1,N
	  	X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
        	X2=XL(KN(J))
			Y2=YL(KN(J))
        	AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
        	BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
        	AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
          IF (I.EQ.J.AND.N.EQ.IN) THEN
          	V(I,J)=AL**3/96./PI*(DLOG(AL/2.)-1./3.)/D
				VN(I,J)=0.
				LV(I,J)=1./2./PI*DLOG(AL/2.)*AL/D
				LVN(I,J)=0.
          ELSE
C
C  Compute the line integrals with 4 point Gauss integration 
C
				DO K=1,4
			  	XC=0.
					YC=0.
					XC=AX*XI(K)+BX
					YC=AY*XI(K)+BY
					R=0.
					R=SQRT((X0-XC)**2+(Y0-YC)**2)
					DX=XC-X0
					DY=YC-Y0
					COSA=DX/R
					SINA=DY/R
					RN=COSA*ENX+SINA*ENY
					RT=SINA*ENX-COSA*ENY
					PR=0.
					PR=1./8./PI/D*R*RN*(2.*DLOG(R)+1.)
					VN(I,J)=VN(I,J)+PR*WG(K)*AL/2.
					PR=0.
 					PR=1./8./PI/D*R**2*DLOG(R)
					V(I,J)=V(I,J)+PR*WG(K)*AL/2.
					PR=0.
					PR=1./2./PI/D*(DLOG(R)+1.)
					LV(I,J)=LV(I,J)+PR*WG(K)*AL/2.
					PR=0.
 					PR=1./2./PI/R*RN/D
					LVN(I,J)=LVN(I,J)+PR*WG(K)*AL/2.
				ENDDO
			ENDIF
		ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE KERNLMATR1(XL,YL,XIN,YIN,JN,KN,N,IN,VX,VNX,LVX
	1  ,LVNX,VY,VNY,LVY,LVNY)
C
C This subroutine computes the boundary integrals of 
C the first derivatives of Eq. 2.119 
C	           
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XIN(IN),YIN(IN),JN(N),KN(N)
	DIMENSION VX(IN,N),VNX(IN,N)
	DIMENSION VY(IN,N),VNY(IN,N)
	REAL*8 LVX(IN,N),LVNX(IN,N)
	REAL*8 LVY(IN,N),LVNY(IN,N)

	COMMON D,PN
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)
	VX=0.
	VNX=0.
	LVX=0.
	LVNX=0.
 	VY=0.
 	VNY=0.
	LVY=0.
	LVNY=0.
      DO I=1,IN
		X0=XIN(I)
		Y0=YIN(I)
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
C
C	 Compute the line integral with 4 point Gauss integration 
C
			DO K=1,4
				XC=0.
				YC=0.
				XC=AX*XI(K)+BX
				YC=AY*XI(K)+BY
				R=0.
				R=SQRT((X0-XC)**2+(Y0-YC)**2)
				DX=XC-X0
				DY=YC-Y0
				COSA=DX/R
				SINA=DY/R
				RN=COSA*ENX+SINA*ENY
				RT=SINA*ENX-COSA*ENY
C
C      1st derivative with respect to x
C
				RX=(X0-XC)/R
 				RY=(Y0-YC)/R
				PR=0.
				PR=1/8./PI*R*RX*(2.*DLOG(R)+1.)/D
				VX(I,J)=VX(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=1./8.*(2.*RN*RX*dlog(R)+3.*RN*RX
	1 			   +2.*RT*RY*dlog(R)+RT*RY)/Pi/D
				VNX(I,J)=VNX(I,J)+PR*WG(K)*AL/2.
				PR=0.
				PR=1./2.*RX/R/Pi/D
				LVX(I,J)=LVX(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=1./2.*(RT*RY-RN*RX)/R**2/Pi/D
				LVNX(I,J)=LVNX(I,J)+PR*WG(K)*AL/2.
C
C      1st derivative with respect to y
C
				PR=0.
				PR=1./8.*(2.*RN*RY*dlog(R)+3.*RN*RY
	1			   -2.*RT*RX*dlog(R)-RT*RX)/D/Pi
				VNY(I,J)=VNY(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=1/8./PI*R*RY*(2.*DLOG(R)+1.)/D
				VY(I,J)=VY(I,J)+PR*WG(K)*AL/2.
				PR=0.
				PR=1./2.*RY/R/Pi/D
				LVY(I,J)=LVY(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=-1./2.*(RT*RX+RN*RY)/R**2/Pi/D
				LVNY(I,J)=LVNY(I,J)+PR*WG(K)*AL/2.
			ENDDO
		ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE KERNLMATR2(XL,YL,XIN,YIN,JN,KN,N,IN,VXX,VNXX,LVXX
	1  ,LVNXX,VYY,VNYY,LVYY,LVNYY,VXY,VNXY,LVXY,LVNXY)
C
C This subroutine computes the boundary integrals of 
C the Eqs. 2.125a-c 
C	           
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XIN(IN),YIN(IN),JN(N),KN(N)
	DIMENSION VXX(IN,N),VNXX(IN,N),VYY(IN,N),VNYY(IN,N)
	DIMENSION VXY(IN,N),VNXY(IN,N)

	REAL*8 LVXX(IN,N),LVNXX(IN,N),LVYY(IN,N),LVNYY(IN,N)
	REAL*8 LVXY(IN,N),LVNXY(IN,N)

	COMMON D,PN
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)
	VXX=0.
	VNXX=0.
	LVXX=0.
	LVNXX=0.
 	VYY=0.
 	VNYY=0.
	LVYY=0.
	LVNYY=0.
	VXYX=0.
 	VNXY=0.
	LVXY=0.
	LVNXY=0.
      DO I=1,IN
		X0=XIN(I)
		Y0=YIN(I)
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
C
C  Compute the line integral with 4 point Gauss integration 
C
			DO K=1,4
				XC=0.
				YC=0.
				XC=AX*XI(K)+BX
				YC=AY*XI(K)+BY
				R=0.
				R=SQRT((X0-XC)**2+(Y0-YC)**2)
				DX=XC-X0
				DY=YC-Y0
				COSA=DX/R
				SINA=DY/R
				RN=COSA*ENX+SINA*ENY
				RT=SINA*ENX-COSA*ENY
C
C  2nd derivative with respect to x
C
				RX=(X0-XC)/R
 				RY=(Y0-YC)/R
				PR=0.
				PR=1./8.*(2.*DLOG(R)+3.*RX**2+RY**2)/PI/D
				VXX(I,J)=VXX(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=1./4.*(RN+2.*RT*RY*RX)/PI/R/D
				VNXX(I,J)=VNXX(I,J)+PR*WG(K)*AL/2.
				PR=0.
				PR=1./2.*(RY**2-RX**2)/R**2/PI/D
				LVXX(I,J)=LVXX(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=-(RN*RY**2+2.*RT*RY*RX-RX**2*RN)/R**3/PI/D
				LVNXX(I,J)=LVNXX(I,J)+PR*WG(K)*AL/2.
C
C  2nd derivative with respect to y
C
				PR=0.
				PR=1./4.*(RN-2.*RT*RY*RX)/PI/R/D
				VNYY(I,J)=VNYY(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=1./8.*(2.*dlog(R)+3.*RY**2+RX**2)/PI/D
				VYY(I,J)=VYY(I,J)+PR*WG(K)*AL/2.
				PR=0.
				PR=-1./2.*(-RX**2+RY**2)/R**2/PI/D
				LVYY(I,J)=LVYY(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=-(RX**2*RN-2.*RT*RY*RX-RN*RY**2)/R**3/PI/D
				LVNYY(I,J)=LVNYY(I,J)+PR*WG(K)*AL/2.
C
C  2nd mixed derivative xy
C
				PR=0.
				PR=-1./4.*RT*(-RY**2+RX**2)/PI/R/D
				VNXY(I,J)=VNXY(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=1./4./PI*RX*RY/D
				VXY(I,J)=VXY(I,J)+PR*WG(K)*AL/2.
				PR=0.
				PR=-RX*RY/R**2/PI/D
				LVXY(I,J)=LVXY(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=(2.*RN*RY*RX-RT*RY**2+RT*RX**2)/R**3/PI/D
				LVNXY(I,J)=LVNXY(I,J)+PR*WG(K)*AL/2.
			ENDDO
		ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE WINTERPL(N,XL,YL,XM,YM,JN,KN,XIN,YIN,IN,XSL,YSL,JLS
	1  ,KLS,NELS,NLS,XPS,YPS,NPS,XLL,YLL,JL,KL,NLL,NLT,FLL,XCL,YCL
     1  ,NCL,FCL,WB,WN,LW,LWN,SL,SP,W,WX,WY,WXX,WYY,WXY,LWX,LWY)
C
C   This subroutine computes the values of w,wx,wy,wxx,wyy,wxy,Lwx,Lwy
C   at the IN internal points
C
	IMPLICIT REAL*8 (A-H,O-Z)
	COMMON D,PN
 	DIMENSION XIN(IN),YIN(IN),XL(N),YL(N),XM(N),YM(N),JN(N),KN(N)
 	DIMENSION XSL(NELS+NLS),YSL(NELS+NLS),JLS(NELS),KLS(NELS),SL(NELS)
	DIMENSION SP(NPS),XPS(NPS),YPS(NPS)
 	DIMENSION UL(IN,NELS),ULX(IN,NELS),ULY(IN,NELS)
 	DIMENSION ULXX(IN,NELS),ULYY(IN,NELS),ULXY(IN,NELS)
	REAL*8 LULX(IN,NELS),LULY(IN,NELS)
	DIMENSION UP(IN,NPS),UPX(IN,NPS),UPY(IN,NPS),UPXX(IN,NPS)
 	DIMENSION UPYY(IN,NPS),UPXY(IN,NPS)
	REAL*8	LUPY(IN,NPS),LUPX(IN,NPS)
 	REAL*8 V(IN,N),VN(IN,N),LV(IN,N),LVN(IN,N)
	REAL*8 VX(IN,N),VNX(IN,N),LVX(IN,N),LVNX(IN,N)
   	REAL*8 VY(IN,N),VNY(IN,N),LVY(IN,N),LVNY(IN,N)
	REAL*8 VXX(IN,N),VNXX(IN,N),LVXX(IN,N),LVNXX(IN,N)
 	REAL*8 VYY(IN,N),VNYY(IN,N),LVYY(IN,N),LVNYY(IN,N)
	REAL*8 VXY(IN,N),VNXY(IN,N),LVXY(IN,N),LVNXY(IN,N)
	DIMENSION WB(N),WN(N)
	DIMENSION P1(IN),PX(IN),PY(IN),PXX(IN),PXY(IN),PYY(IN)
	REAL*8    LPX(IN),LPY(IN),LW(N),LWN(N),LWX(IN),LWY(IN)
	DIMENSION XLL(NLL+NLT),YLL(NLL+NLT),JL(NLL),KL(NLL),FLL(NLL)
	DIMENSION XCL(NCL),YCL(NCL),FCL(NCL)
	DIMENSION W(IN),WX(IN),WY(IN),WXX(IN),WXY(IN),WYY(IN)

	CALL FLOADIN(XL,YL,XM,YM,JN,KN,N,IN,XIN,YIN,XLL,YLL,JL,KL
	1 ,NLT,NLL,FLL,XCL,YCL,NCL,FCL,P1,PX,PY,PXX,PYY,PXY,LPX,LPY)
C
C  Compute matrices for line supports
C
      IF (NLS.GT.0) THEN
		CALL UINDERLMATR(XIN,YIN,IN,XSL,YSL,JLS,KLS,NLS,NELS,UL,ULX
	&	     ,ULY,ULXX,ULYY,ULXY,LULX,LULY)
		DO I=1,IN
			DO J=1,NELS
				P1(I)=P1(I)+UL(I,J)*SL(J)
				PX(I)=PX(I)+ULX(I,J)*SL(J)
				PY(I)=PY(I)+ULY(I,J)*SL(J)
				PXX(I)=PXX(I)+ULXX(I,J)*SL(J)
				PXY(I)=PXY(I)+ULXY(I,J)*SL(J)
				PYY(I)=PYY(I)+ULYY(I,J)*SL(J)
	  		    LPX(I)=LPX(I)+LULX(I,J)*SL(J)
				LPY(I)=LPY(I)+LULY(I,J)*SL(J)
			ENDDO
		ENDDO
	ENDIF
C
C  Compute matrices for point supports
C
	IF (NPS.GT.0) THEN
		CALL UINDERPMATRIN(XPS,YPS,NPS,XIN,YIN,IN,UP,UPX,UPY
	1					   ,UPXX,UPYY,UPXY,LUPX,LUPY) 
		DO I=1,IN
			DO J=1,NPS
				P1(I)=P1(I)+UP(I,J)*SP(J)
				PX(I)=PX(I)+UPX(I,J)*SP(J)
				PY(I)=PY(I)+UPY(I,J)*SP(J)
				PXX(I)=PXX(I)+UPXX(I,J)*SP(J)
				PXY(I)=PXY(I)+UPXY(I,J)*SP(J)
				PYY(I)=PYY(I)+UPYY(I,J)*SP(J)
				LPX(I)=LPX(I)+LUPX(I,J)*SP(J)
				LPY(I)=LPY(I)+LUPY(I,J)*SP(J)
			ENDDO
		ENDDO
	ENDIF
	CALL KERNLMATR (XL,YL,XIN,YIN,JN,KN,N,IN,V,VN,LV,LVN)
	CALL KERNLMATR1(XL,YL,XIN,YIN,JN,KN,N,IN,VX,VNX,LVX
	1  ,LVNX,VY,VNY,LVY,LVNY)
	CALL KERNLMATR2(XL,YL,XIN,YIN,JN,KN,N,IN,VXX,VNXX,LVXX,LVNXX,
 	1           VYY,VNYY,LVYY,LVNYY,VXY,VNXY,LVXY,LVNXY)
	W=0.
	W=-MATMUL(V,LWN)+MATMUL(LVN,WB)+MATMUL(VN,LW)
	&   - MATMUL(LV,WN)
	WX=0.
	WX=-MATMUL(VX,LWN)+MATMUL(LVNX,WB)+MATMUL(VNX,LW)
	&   - MATMUL(LVX,WN)
	WY=0.
	WY=-MATMUL(VY,LWN)+MATMUL(LVNY,WB)+MATMUL(VNY,LW)
	&   - MATMUL(LVY,WN)
	WXX=0.
	WXX=-MATMUL(VXX,LWN)+MATMUL(LVNXX,WB)+MATMUL(VNXX,LW)
	&   - MATMUL(LVXX,WN)
	WXY=0.
	WXY=-MATMUL(VXY,LWN)+MATMUL(LVNXY,WB)+MATMUL(VNXY,LW)
	&   - MATMUL(LVXY,WN)
	WYY=0.
 	WYY=-MATMUL(VYY,LWN)+MATMUL(LVNYY,WB)+MATMUL(VNYY,LW)
	&   - MATMUL(LVYY,WN)
	LWX=0.
	LWX=-MATMUL(LVX,LWN)+MATMUL(LVNX,LW)
	LWY=0.
	LWY=-MATMUL(LVY,LWN)+MATMUL(LVNY,LW)

	DO I=1,IN
	  W(I)=P1(I)   +D*W(I)
	  WX(I)=PX(I)  +D*WX(I)
	  WY(I)=PY(I)  +D*WY(I)
	  WXX(I)=PXX(I)+D*WXX(I)
	  WXY(I)=PXY(I)+D*WXY(I)
	  WYY(I)=PYY(I)+D*WYY(I)
 	  LWX(I)=LPX(I)+D*LWX(I)
	  LWY(I)=LPY(I)+D*LWY(I)
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE STRESSPL(IN,WXX,WYY,WXY,LWX,LWY,MX,MY,MXY,QX,QY)
C
C   This subroutine computes the stress resultants at the IN internal 
C   points
C
	IMPLICIT REAL*8 (A-H,O-Z)
	COMMON D,PN
	REAL*8    LWX(IN),LWY(IN),MX(IN),MY(IN),MXY(IN)
	DIMENSION WXX(IN),WXY(IN),WYY(IN),QX(IN),QY(IN)

	DO I=1,IN
	  MX(I)=-D*(WXX(I)+PN*WYY(I))
	  MY(I)=-D*(WYY(I)+PN*WXX(I))
	  MXY(I)=D*(1.-PN)*WXY(I)
	  QY(I)=-D*LWY(I)
	  QX(I)=-D*LWX(I)
	ENDDO

	RETURN
	END
C
C===================================================================
C
      SUBROUTINE  CORNERPL(WC,TW,XM,YM,XL,YL,XC,YC,JN,KN,CCODE,WN,N
     1                    ,NFC,NC,FCORN,WCORN)
C
C   This subroutine computes the corner forces
C
	IMPLICIT REAL*8 (A-H,O-Z)
	COMMON D,PN
      DIMENSION XM(N),YM(N),XL(N),YL(N),ICOR(NC,2),XC(NC),YC(NC)
	DIMENSION WN(N),TW(NFC),JN(N),KN(N)
	INTEGER CCODE(NC)
	DIMENSION FCORN(NC),WCORN(NC),WC(NFC)
	J=0
	R=0.
	K=0
	ICOR=0
	DO I=1,NC
	  IF (CCODE(I).EQ.0) THEN
         J=J+1
		  DO L=1,N
			  R1=DSQRT((XL(KN(L))-XC(I))**2+(YL(KN(L))-YC(I))**2)
			  R2=DSQRT((XL(JN(L))-XC(I))**2+(YL(JN(L))-YC(I))**2)
			  IF (R1.LT.0.0001) THEN 
				  ICOR(J,1)=L
					ELSEIF (R2.LT.0.0001) THEN
				  ICOR(J,2)=L
	    ENDIF
				ENDDO
	   X1=XM(ICOR(J,2))
	   X2=XM(ICOR(J,2)+1)
	   X3=XM(ICOR(J,2)+2)
	   Y1=YM(ICOR(J,2))
 	   Y2=YM(ICOR(J,2)+1)
	   Y3=YM(ICOR(J,2)+2)
         S1=DSQRT((X1-X2)**2+(Y1-Y2)**2)
	   S2=DSQRT((X1-X2)**2+(Y1-Y2)**2)
	   A1=-(2.*S1+S2)/S1/(S1+S2)
	   A2=(S1+S2)/S1/S2
	   A3=-S1/S2/(S1+S2)
	   WNTAFTER=A1*WN(ICOR(J,2))+A2*WN(ICOR(J,2)+1)
     1     +A3*WN(ICOR(J,2)+2)
	   X1=XM(ICOR(J,1))
	   X2=XM(ICOR(J,1)-1)
	   X3=XM(ICOR(J,1)-2)
	   Y1=YM(ICOR(J,1))
 	   Y2=YM(ICOR(J,1)-1)
	   Y3=YM(ICOR(J,1)-2)
         S1=DSQRT((X1-X2)**2+(Y1-Y2)**2)
	   S2=DSQRT((X1-X2)**2+(Y1-Y2)**2)
	   A1=(2.*S1+S2)/S1/(S1+S2)
	   A2=-(S1+S2)/S1/S2
	   A3=S1/S2/(S1+S2)
	   WNTBEFORE=A1*WN(ICOR(J,1))+A2*WN(ICOR(J,1)-1)
     1    +A3*WN(ICOR(J,1)-2)
	   FCORN(I)=D*(1.-PN)*(WNTAFTER-WNTBEFORE)
	   WCORN(I)=0.
	  ELSE
	   K=K+1
	   FCORN(I)=TW(K)
	   WCORN(I)=WC(K)
	  ENDIF
	ENDDO

	RETURN
	END 
C	
C====================================================================
C
	SUBROUTINE FLOADPL(XL,YL,XM,YM,JN,KN,N,NFC,XFC,YFC,NELS,XSM,YSM
	1          ,XPS,YPS,NPS,XLL,YLL,JL,KL,NLL,NELL,FLL
     1          ,XCL,YCL,NCL,FCL,FLOAD,FLOADL)
C
C This subroutine computes the vector of Eq. 2.134
C
 	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N)
	DIMENSION XSM(NELS),YSM(NELS),XFC(NFC),YFC(NFC)
	DIMENSION XPS(NPS),YPS(NPS)
	DIMENSION XLL(NELL+NLL),YLL(NELL+NLL),JL(NELL),KL(NELL)
	DIMENSION XCL(NCL),YCL(NCL),FCL(NCL),FLL(NELL+NLL)
	DIMENSION FLOAD(2*N+NFC+NELS+NPS),FLOADL(2*N)
C
C  Compute the domain integrals for linear surface loads  
C
	CALL FLOAD2D(XL,YL,XM,YM,JN,KN,N,NFC,XFC,YFC,NELS,XSM,YSM
	#          ,XPS,YPS,NPS,FLOAD,FLOADL)
C
C  Compute the line integrals for line loads  
C

	CALL FLOADLINE(XLL,YLL,JL,KL,NLL,NELL,FLL,XL,YL,XM,YM,JN,KN,
	1           XFC,YFC,N,NFC,NELS,XSM,YSM,NPS,XPS,YPS,FLOAD,FLOADL)
C
C  Compute the vectors for point loads 
C
	CALL FLOADPOINT(XCL,YCL,NCL,FCL,XL,YL,XM,YM,JN,KN,
	1           XFC,YFC,N,NFC,NELS,XSM,YSM,NPS,XPS,YPS,FLOAD,FLOADL)

	RETURN
	END
C	
C====================================================================
C
	SUBROUTINE FLOADIN(XL,YL,XM,YM,JN,KN,N,IN,XIN,YIN,XLL,YLL,JL,KL
	# ,NLL,NELL,FLL,XCL,YCL,NCL,FCL,P1,PX,PY,PXX,PYY,PXY,LPX,LPY)
C
C  This subroutine computes the vectors of the surface, line and point
C  loads for the Eqs 2.119, 2.125a-e
C
 	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N),XIN(IN),YIN(IN)
	DIMENSION XLL(NELL+NLL),YLL(NELL+NLL),JL(NELL),KL(NELL)
	DIMENSION XCL(NCL),YCL(NCL),FCL(NCL),FLL(NELL+NLL)

	DIMENSION P1(IN),PX(IN),PY(IN),PXX(IN),PXY(IN),PYY(IN)
	REAL*8    LPX(IN),LPY(IN)

C
C  Compute the domain integrals of the Eq.2.119,2.125a-e
C  
	CALL FLOAD2DIN (XL,YL,XM,YM,XIN,YIN,JN,KN,N,IN,P1,PX,PY
	&   ,PXX,PYY,PXY,LPX,LPY)
C
C  Compute the vectors of line loads
C
	CALL LINELOADIN(XLL,YLL,JL,KL,NLL,NELL,FLL,XIN,YIN,IN,P1,
	&    PX,PY,PXX,PYY,PXY,LPX,LPY)
C
C  Compute the vectors of point loads
C
	CALL POINTLOADIN(XCL,YCL,NCL,FCL,XIN,YIN,IN,P1,
	&         PX,PY,PXX,PYY,PXY,LPX,LPY)

	RETURN
	END
C	
C====================================================================
C
	SUBROUTINE FLOAD2D(XL,YL,XM,YM,JN,KN,N,NFC,XFC,YFC,NELS,XSM,YSM
	#          ,XPS,YPS,NPS,FLOAD,FLOADL)
C
C  This subroutine computes the domain integrals of the Eq.2.93,2.118
C  by trasforming them to boundary line integrals

C
C  FLOAD=[F1 F2 F3 F5 F6] 
C  FLOADL=[F1	F4]
C
 	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N)
	#          ,XFC(NFC),YFC(NFC),FLOADL(2*N)
	DIMENSION F(N),FN(N),UH(N,N),UHN(N,N),UHC(NFC,N),UHNC(NFC,N)
	#          ,U1H(N,N),U1HN(N,N)
	REAL*8 LUH(N,N),LUHN(N,N)
	DIMENSION XSM(NELS),YSM(NELS),UHL(NELS,N),UHLN(NELS,N),F5(NELS)

	DIMENSION XPS(NPS),YPS(NPS),UHP(NPS,N),UHPN(NPS,N),F6(NPS)
	DIMENSION F1(N),F2(N),F3(NFC),F4(N),FLOAD(2*N+NFC+NELS+NPS)
C
C  Compute the boundary values of the domain load and its
C  normal derivative
C
	CALL LINSURFL (XL,YL,XM,YM,JN,KN,N,F,FN)
C
C  Compute the kernels of Eq. 2.167a 
C
	CALL UHATMATR (XL,YL,XM,YM,JN,KN,N,N,UH,UHN)
C
C  Compute the kernels of Eq. 2.167c 
C
  	CALL U1HATMATR (XL,YL,XM,YM,JN,KN,N,U1H,U1HN)
C
C  Compute the kernels of Eq. 2.167b 
C
	IF (NFC.GT.0) THEN
		CALL UCHATMATR (XL,YL,JN,KN,XFC,YFC,N,NFC,UHC,UHNC)
	ENDIF
C
C  Compute the kernels of Eq. 2.167a at the elements on line loads  
C
	IF (NELS.GT.0) THEN
      CALL UHATMATR(XL,YL,XSM,YSM,JN,KN,N,NELS,UHL,UHLN)
	ENDIF
C
C  Compute the kernels of Eq. 2.167a at the point loads  
C
	IF (NPS.GT.0) THEN
      CALL UHATMATR(XL,YL,XPS,YPS,JN,KN,N,NPS,UHP,UHPN)
	ENDIF
C
C  Compute the kernels of Eq. 2.120		
C							  
	CALL LUHATMATR (XL,YL,XM,YM,JN,KN,N,N,LUH,LUHN)

	F1=0.
 	F2=0.
	F3=0.
	F4=0.
	F5=0.
	F6=0.
	DO I=1,N
		DO J=1,N
			F1(I)=F1(I)+UHN(I,J)*F(J)-UH(I,J)*FN(J)
			F2(I)=F2(I)+U1HN(I,J)*F(J)-U1H(I,J)*FN(J)
			F4(I)=F4(I)+LUHN(I,J)*F(J)-LUH(I,J)*FN(J)
		ENDDO
	ENDDO
	F3=0.
	DO I=1,NFC
		DO J=1,N
			F3(I)=F3(I)+UHNC(I,J)*F(J)-UHC(I,J)*FN(J)
		ENDDO
	ENDDO

	F5=0.
	DO I=1,NELS
		DO J=1,N
			F5(I)=F5(I)+UHLN(I,J)*F(J)-UHL(I,J)*FN(J)
		ENDDO
	ENDDO

	F6=0.
	DO I=1,NPS
		DO J=1,N
			F6(I)=F6(I)+UHPN(I,J)*F(J)-UHP(I,J)*FN(J)
		ENDDO
	ENDDO
	FLOAD=0.
	FLOADL=0.
	DO I=1,N
		FLOAD(I)=F1(I)
		FLOAD(I+N+NFC)=F2(I)
		FLOADL(I)=F1(I)
		FLOADL(I+N)=F4(I)
	ENDDO
	DO I=1,NFC
		FLOAD(I+N)=F3(I)
	ENDDO
	DO I=1,NELS
		FLOAD(I+2*N+NFC)=F5(I)
	ENDDO
	DO I=1,NPS
	  FLOAD(I+2*N+NFC+NELS)=F6(I)
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE LINSURFL(XL,YL,XM,YM,JN,KN,N,F,FN)
C
C  This subroutine computes the load function values F=FX*x+FY*y+F0 
C  and its normal derivative dF/dn at the boundary points
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N)
	DIMENSION F(N),FN(N)
	COMMON /SURFLOAD/ FX,FY,F0

	DO I=1,N
		F(I)= FX*XM(I) + FY*YM(I) + F0
		X1=XL(JN(I))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
 		Y1=YL(JN(I))
		X2=XL(KN(I))
  		Y2=YL(KN(I))
		AX=(X2-X1)/2.
		AY=(Y2-Y1)/2.
		BX=(X2+X1)/2.
		BY=(Y2+Y1)/2.
		AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
		ENX=2.*AY/AL
		ENY=-2.*AX/AL
		FN(I)=FX*ENX+FY*ENY
	ENDDO
	
	RETURN
	END
C
C====================================================================
C
	SUBROUTINE UHATMATR (XL,YL,XM,YM,JN,KN,N,IN,UH,UHN)
C
C  This subroutine computes the kernels of the boundary 
C  integral of Eq. 2.162 when the source point is on a smooth 
C  boundary point
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(IN),YM(IN),JN(N),KN(N)
	DIMENSION UH(IN,N),UHN(IN,N)
	COMMON D,PN
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)
	UH=0
	UHN=0.
      DO I=1,IN
		X0=XM(I)
		Y0=YM(I)
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
			IF (I.EQ.J.AND.N.EQ.IN) THEN 
 				UH(I,J)=0.
				UHN(I,J)=0.
  			ELSE
C
C	 Compute the line integral with 4 point Gauss integration 
C
			DO K=1,4
				XC=0
				YC=0
				XC=AX*XI(K)+BX
				YC=AY*XI(K)+BY
				R=0
				R=SQRT((X0-XC)**2+(Y0-YC)**2)
				DX=XC-X0
				DY=YC-Y0
				COSA=DX/R
				SINA=DY/R
				RN=COSA*ENX+SINA*ENY
		    UH(I,J)=UH(I,J)+(1./256./D/PI*R**4*(2.*DLOG(R)-1.))
	&				*WG(K)*AL/2.
 		    UHN(I,J)=UHN(I,J)+(1./128./D/PI*R**3*RN*(4.*DLOG(R)-1.))
	&	        *WG(K)*AL/2.
				ENDDO
			ENDIF
		ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE UCHATMATR (XL,YL,JN,KN,XCN,YCN,N,NC,UHC,UHNC)
C
C  This subroutine computes the kernels of the boundary 
C  integral of Eq. 2.162 when the source point is on corner 
C  boundary point
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),JN(N),KN(N),XCN(NC),YCN(NC)
	DIMENSION UHC(NC,N),UHNC(NC,N)
	COMMON D,PN
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)
	UHC=0.
	UHNC=0.

	DO I=1,NC
		X0=XCN(I)
		Y0=YCN(I)
		K3=0.
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
			R1=0.
 			R2=0.
  			R1=SQRT((X0-X1)**2+(Y0-Y1)**2)
			R2=SQRT((X0-X2)**2+(Y0-Y2)**2)
			K3=K3+1
			IF (R1.LT.0.0001.OR.R2.LT.0.0001) THEN
 				UHC(I,K3)=1./6400./PI/D*AL**5*(10.*DLOG(AL)-7.)
				UHNC(I,K3)=0.
	  	ELSE
C
C	 Compute the line integral with 4 point Gauss integration 
C
				DO K=1,4
					XC=0
					YC=0
					XC=AX*XI(K)+BX
					YC=AY*XI(K)+BY
					R=0.
					R=SQRT((X0-XC)**2+(Y0-YC)**2)
					DX=XC-X0
					DY=YC-Y0
					COSA=DX/R
					SINA=DY/R
					RN=COSA*ENX+SINA*ENY
		   UHC(I,K3)=UHC(I,K3)+(1./256./D/PI*R**4*(2.*DLOG(R)-1.))
	&				*WG(K)*AL/2.
 	
					UHNC(I,K3)=UHNC(I,K3)+(1./128./D/PI*R**3*RN*
	&					(4.*DLOG(R)-1.))*WG(K)*AL/2.
				ENDDO
			ENDIF
		ENDDO
	ENDDO

	
	RETURN
	END

C
C====================================================================
C
 	SUBROUTINE U1HATMATR (XL,YL,XM,YM,JN,KN,N,U1H,U1HN)
C
C  This subroutine computes the kernels of the boundary 
C  integral of Eq. 2.165 when the source point is on a smooth 
C  boundary point
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N)
	DIMENSION U1H(N,N),U1HN(N,N)
	COMMON D,PN
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)
	U1H=0.
	U1HN=0.

      DO I=1,N
		X0=XM(I)
		Y0=YM(I)
		XA1=XL(JN(I))
		YA1=YL(JN(I))
		XA2=XL(KN(I))
		YA2=YL(KN(I))
		AAL=SQRT((XA1-XA2)**2+(YA1-YA2)**2)
		AAX=(XA2-XA1)/2.
 		AAY=(YA2-YA1)/2.
		ENAX=2.*AAY/AAL
 		ENAY=-2.*AAX/AAL
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
			IF (I.EQ.J) THEN 
				U1H(I,J)=0.
				U1HN(I,J)=0.
			ELSE
C
C	 Compute the line integral with 4 point Gauss integration 
C
				DO K=1,4
					XC=0
					YC=0
					XC=AX*XI(K)+BX
					YC=AY*XI(K)+BY
					R=0
					R=SQRT((X0-XC)**2+(Y0-YC)**2)
					DX=XC-X0
					DY=YC-Y0
					COSA=DX/R
					SINA=DY/R
					RN=COSA*ENX+SINA*ENY
					RT=SINA*ENX-COSA*ENY
					RAN=-COSA*ENAX-SINA*ENAY
					RAT=COSA*ENAY-SINA*ENAX
		U1H(I,J)=U1H(I,J)+(1./128./PI/D*R**3*RAN*(4*DLOG(R)-1.))
	&					*WG(K)*AL/2.
				U1HN(I,J)=U1HN(I,J)+(1./128./PI/D*R**2*(RN*RAN*
	&		(12.*DLOG(R)+1.)+RT*RAT*(4.*DLOG(R)-1.)))*WG(K)*AL/2.
				ENDDO
			ENDIF
		ENDDO
	ENDDO


	RETURN
	END
C
C====================================================================
C
	SUBROUTINE LUHATMATR (XL,YL,XM,YM,JN,KN,N,IN,UH,UHN)
C
C  This subroutine computes the kernels of the boundary integrals 
C  used for the evaluation of the domain integral of Eq. 2.120 
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N)
	DIMENSION UH(IN,N),UHN(IN,N)
	COMMON D,PN
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)
	UH=0
	UHN=0.

      DO I=1,IN
		X0=XM(I)
		Y0=YM(I)
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
			IF (I.EQ.J.AND.N.EQ.IN) THEN 
 				UH(I,J)=0.
				UHN(I,J)=0.
  			ELSE
C
C	 Compute the line integral with 4 point Gauss integration 
C
				DO K=1,4
					XC=0
					YC=0
					XC=AX*XI(K)+BX
					YC=AY*XI(K)+BY
					R=0
					R=SQRT((X0-XC)**2+(Y0-YC)**2)
					DX=XC-X0
					DY=YC-Y0
					COSA=DX/R
					SINA=DY/R
					RN=COSA*ENX+SINA*ENY
				UH(I,J)=UH(I,J)+(1./8./D/PI*R**2*DLOG(R))*WG(K)*AL/2.
			UHN(I,J)=UHN(I,J)+(1./8./D/PI*R*RN*(2.*DLOG(R)+1.))
	&					*WG(K)*AL/2.
				ENDDO
			ENDIF
		ENDDO
	ENDDO

	RETURN
	END

C
C====================================================================
C			   
	SUBROUTINE FLOAD2DIN(XL,YL,XM,YM,XIN,YIN,JN,KN,N,IN,F1,FX,FY
	#   ,FXX,FYY,FXY,LFX,LFY)
C
C  This subroutine computes the domain integrals of Eq. 2.119 
C  and 2.125a-2.125e, when the source point is at the interior of the domain
C  by transforming them to boundary line	integrals
C

	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XIN(IN),YIN(IN),JN(N),KN(N),XM(N),YM(N)
	DIMENSION F(N),FN(N)
	DIMENSION UP(IN,N),UPN(IN,N),F1(IN)
	DIMENSION UPX(IN,N),UPXN(IN,N),FX(IN)
	DIMENSION UPY(IN,N),UPYN(IN,N),FY(IN)
	DIMENSION UPXX(IN,N),UPXXN(IN,N),FXX(IN)
	DIMENSION UPYY(IN,N),UPYYN(IN,N),FYY(IN)
	DIMENSION UPXY(IN,N),UPXYN(IN,N),FXY(IN)
	REAL*8 LUPX(IN,N),LUPXN(IN,N),LFX(IN)
	REAL*8 LUPYN(IN,N),LUPY(IN,N),LFY(IN)

	COMMON D,PN
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)


	UP=0.
	UPN=0.
	UPX=0.
	UPXN=0.
	UPY=0.
	UPYN=0.
	UPXX=0.
	UPXXN=0.
	UPYY=0.
	UPYYN=0.
	UPXY=0.
	UPXYN=0.
	LUPX=0.
	LUPXN=0.
	LUPY=0.
	LUPYN=0.

      DO I=1,IN
		X0=XIN(I)
		Y0=YIN(I)
		DO J=1,N
			X1=XL(JN(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YL(JN(J))
			X2=XL(KN(J))
			Y2=YL(KN(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
C
C	 Compute the line integral with 4 point Gauss integration 
C
			DO K=1,4
				XC=0.
				YC=0.
				XC=AX*XI(K)+BX
				YC=AY*XI(K)+BY
				R=0
				R=SQRT((X0-XC)**2+(Y0-YC)**2)
				DX=XC-X0
				DY=YC-Y0
				COSA=DX/R
				SINA=DY/R
				RN=COSA*ENX+SINA*ENY
				RT=SINA*ENX-COSA*ENY
				RX=(X0-XC)/R
 				RY=(Y0-YC)/R

C--------For Eq. 2.119--------------------------------
 				P=1./256./D/PI*R**4*(2.*DLOG(R)-1.)
				UP(I,J)=UP(I,J)+P*WG(K)*AL/2.

				P=1./128./D/PI*R**3*RN*(4.*DLOG(R)-1.)
				UPN(I,J)=UPN(I,J)+P*WG(K)*AL/2.

C--------For 1st  derivative-------------------------- 
				P=1./128./D/PI*R**3*RX*(4.*DLOG(R)-1.)
				UPX(I,J)=UPX(I,J)+P*WG(K)*AL/2.

				P=R**2/128./PI/D*(RN*RX*(12.*DLOG(R)+1.)
	&				+RT*RY*(4.*DLOG(R)-1.))
				UPXN(I,J)=UPXN(I,J)+P*WG(K)*AL/2.

				P=1./128./D/PI*R**3*RY*(4.*DLOG(R)-1.)
				UPY(I,J)=UPY(I,J)+P*WG(K)*AL/2.

 				P=R**2/128./PI/D*(RN*RY*(12.*DLOG(R)+1.)
	&				+RT*RX*(1.-4.*DLOG(R)))
				UPYN(I,J)=UPYN(I,J)+P*WG(K)*AL/2.

C--------For 2nd  derivative Eq. 2.125a-c--------------------------
				P=2.*r**2*(12.*rx**2*dlog(r)+rx**2+4.*ry**2*dlog(r)
	&   			  -ry**2)/256./pi/D

				UPXX(I,J)=UPXX(I,J)+P*WG(K)*AL/2.

 				P=4.*r*(12.*rn*rx**2*dlog(r)+7.*rn*rx**2
	& 			  +4.*rn*ry**2*dlog(r)+rn*ry**2+8*rx*rt*ry*dlog(r)
     &      +2.*rx*rt*ry)/256./pi/D

				UPXXN(I,J)=UPXXN(I,J)+P*WG(K)*AL/2.

				P=2.*r**2*(12.*ry**2*dlog(r)+ry**2+4.*rx**2*dlog(r)
	&   			  -rx**2)/256./pi/D
				
				UPYY(I,J)=UPYY(I,J)+P*WG(K)*AL/2.
 	
				P=4.*r*(12.*rn*ry**2*dlog(r)+7.*rn*ry**2
	&			  +4.*rn*rx**2*dlog(r)+rn*rx**2-8.*rx*rt*ry*dlog(r)
     &     -2.*rx*rt*ry)/256./pi/D
				
				UPYYN(I,J)=UPYYN(I,J)+P*WG(K)*AL/2.

				P=4.*r**2*rx*ry*(4.*DLOG(r)+1.)/256./pi/D
				
				UPXY(I,J)=UPXY(I,J)+P*WG(K)*AL/2.
 	
				P=-4.*r*(-8.*rx*ry*rn*DLOG(r)-6.*rx*ry*rn
	& 		  -4.*ry**2*rt*DLOG(r)-ry**2*rt+4.*rx**2*rt*DLOG(r)
     &     +rx**2*rt)/256./pi/D

				UPXYN(I,J)=UPXYN(I,J)+P*WG(K)*AL/2.

C--------For third derivatives Eq. 2.125d-e ----------------
 
				P=1./8.*R*RX*(2.*dlog(R)+1.)/Pi/D
				LUPX(I,J)=LUPX(I,J)+P*WG(K)*AL/2.
	
				P=1./8.*(3.*RN*RX+2.*RN*RX*DLOG(R)+RT*RY
	&				+2.*RT*RY*DLOG(R))/Pi/D

				LUPXN(I,J)=LUPXN(I,J)+P*WG(K)*AL/2.

				P=1./8.*R*RY*(2.*dlog(R)+1.)/Pi/D
				LUPY(I,J)=LUPY(I,J)+P*WG(K)*AL/2.
	
				P=1./8.*(3.*RN*RY+2.*RN*RY*DLOG(R)-RT*RX-
	&				2.*RT*RX*DLOG(R))/Pi/D

				LUPYN(I,J)=LUPYN(I,J)+P*WG(K)*AL/2.

			ENDDO
		ENDDO
	ENDDO

	CALL LINSURFL(XL,YL,XM,YM,JN,KN,N,F,FN)
	F1=0.
	FX=0.
	FY=0.
	FXX=0.
 	FYY=0.
	FXY=0.
	LFX=0.
	LFY=0.

	DO I=1,IN
		DO J=1,N
			F1(I)=F1(I)+F(J)*UPN(I,J)-FN(J)*UP(I,J)
			FX(I)=FX(I)+F(J)*UPXN(I,J)-FN(J)*UPX(I,J)
			FY(I)=FY(I)+F(J)*UPYN(I,J)-FN(J)*UPY(I,J)

			FXX(I)=FXX(I)+F(J)*UPXXN(I,J)-FN(J)*UPXX(I,J)
			FYY(I)=FYY(I)+F(J)*UPYYN(I,J)-FN(J)*UPYY(I,J)
			FXY(I)=FXY(I)+F(J)*UPXYN(I,J)-FN(J)*UPXY(I,J)

			LFX(I)=LFX(I)+F(J)*LUPXN(I,J)-FN(J)*LUPX(I,J)
			LFY(I)=LFY(I)+F(J)*LUPYN(I,J)-FN(J)*LUPY(I,J)
		ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE FLOADLINE(XLL,YLL,JL,KL,NLL,NELL,FLL,XL,YL,XM,YM,JN,KN
	1          ,XC,YC,N,NC,NSL,XSM,YSM,NPS,XPS,YPS,FLOAD,FLOAD2)
C
C  This subroutine computes the line integrals of Eq. 2.160 for the line 
C  loads in the boundary integral equations
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N)
	DIMENSION XC(NC),YC(NC),XSM(NSL),YSM(NSL),XPS(NPS),YPS(NPS)

	DIMENSION XLL(NLL+NELL),YLL(NLL+NELL),UBL(N,NELL),U1BL(N,NELL)
	DIMENSION UCBL(NC,NELL),JL(NELL),KL(NELL),FLL(NELL)
      DIMENSION P1(N),P2(N),P3(NC)
      DIMENSION UL1(NSL,NELL),UL2(NPS,NELL),P5(NSL),P6(NPS)
      REAL*8 LUBL(N,NELL)
	DIMENSION FLOAD(2*N+NC+NSL+NPS),FLOAD2(2*N+NC),P4(N)

	CALL UINLMATR(XLL,YLL,JL,KL,NELL,NLL,XSM,YSM,NSL,UL1)
	CALL UINLMATR(XLL,YLL,JL,KL,NELL,NLL,XPS,YPS,NPS,UL2)
	CALL UBLMATR(XL,YL,XM,YM,JN,KN,N,XC,YC,NC,XLL,YLL,JL,KL,NLL
     1         ,NELL,UBL,U1BL,UCBL,LUBL)

	P1=0.
	P2=0.
	P3=0.
	P4=0.
	P5=0.
 	P6=0.

	DO J=1,NELL
		DO I=1,N
			P1(I)=P1(I)+UBL(I,J)*FLL(J)
			P2(I)=P2(I)+U1BL(I,J)*FLL(J)
	  	P4(I)=P4(I)+LUBL(I,J)*FLL(J)
		ENDDO
		DO I=1,NC
			P3(I)=P3(I)+UCBL(I,J)*FLL(J)
		ENDDO
		DO I=1,NSL
			P5(I)=P5(I)+UL1(I,J)*FLL(J)
		ENDDO
		DO I=1,NPS
			P6(I)=P6(I)+UL2(I,J)*FLL(J)
		ENDDO
	ENDDO
	DO I=1,N
		FLOAD(I)=FLOAD(I)+P1(I)
		FLOAD2(I)=FLOAD2(I)+P1(I)
		FLOAD2(I+N)=FLOAD2(I+N)+P4(I)
		FLOAD(I+N+NC)=FLOAD(I+N+NC)+P2(I)
	ENDDO
	DO I=1,NC
		FLOAD(I+N)=FLOAD(I+N)+P3(I)
	ENDDO
	DO I=1,NSL
	  FLOAD(I+2*N+NC)=FLOAD(I+2*N+NC)+P5(I)
	ENDDO
	DO I=1,NPS
		FLOAD(I+2*N+NC+NSL)=FLOAD(I+2*N+NC+NSL)+P6(I)
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE UBLMATR(XL,YL,XM,YM,JN,KN,N,XC,YC,NC,XLL,YLL,JL,KL
	1            ,NLL,NL,UBL,U1BL,UCBL,LUBL)

C  This subroutine computes the boundary integrals for the
C  contribution of line loads to the evaluation of the domain 
C  integral of the first and second integral equation
C  when the source point is on the boundary 

	IMPLICIT REAL*8 (A-H,O-Z)  
	COMMON D,PN
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N),XC(NC),YC(NC)
	DIMENSION XLL(NL+NLL),YLL(NLL+NL),UBL(N,NL),U1BL(N,NL)
	DIMENSION UCBL(NC,NL),JL(NL),KL(NL)
	REAL*8 LUBL(N,NL)

	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)
	UBL=0.
	U1BL=0.
	UCBL=0.
	LUBL=0.
      DO I=1,N
		X0=XM(I)
		Y0=YM(I)
		XA1=XL(JN(I))
 	  YA1=YL(JN(I))
		XA2=XL(KN(I))
		YA2=YL(KN(I))
		AAL=SQRT((XA1-XA2)**2+(YA1-YA2)**2)
		AAX=(XA2-XA1)/2.
 		AAY=(YA2-YA1)/2.
		ENAX=2.*AAY/AAL
 		ENAY=-2.*AAX/AAL
		DO J=1,NL
			X1=XLL(JL(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YLL(JL(J))
			X2=XLL(KL(J))
			Y2=YLL(KL(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
	  	AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
C
C	 Compute the line integral with 4 point Gauss integration 
C
			DO K=1,4
				XK=0.
				YK=0.
				XK=AX*XI(K)+BX
				YK=AY*XI(K)+BY
				R=0.
				R=SQRT((X0-XK)**2+(Y0-YK)**2)
				DX=XK-X0
				DY=YK-Y0
				COSA=DX/R
				SINA=DY/R
				RAN=-COSA*ENAX-SINA*ENAY
				PR=0.
				PR=1./8./PI/D*R**2*DLOG(R)
				UBL(I,J)=UBL(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=1./8./PI/D*R*RAN*(2*DLOG(R)+1.)
				U1BL(I,J)=U1BL(I,J)+PR*WG(K)*AL/2.
				PR=0.
 				PR=1./2./PI/D*(DLOG(R)+1.)
				LUBL(I,J)=LUBL(I,J)+PR*WG(K)*AL/2.
			ENDDO
		ENDDO
	ENDDO

	DO I=1,NC
		X0=XC(I)
		Y0=YC(I)
		DO J=1,NL
			X1=XLL(JL(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
 	  	Y1=YLL(JL(J))
			X2=XLL(KL(J))
			Y2=YLL(KL(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
C
C	 Compute the line integral with 4 point Gauss integration 
C
			DO K=1,4
				XK=0
				YK=0
				XK=AX*XI(K)+BX
				YK=AY*XI(K)+BY
				R=0.
				R=SQRT((X0-XK)**2+(Y0-YK)**2)
				PR=0.
				PR=1/8./PI/D*R**2*DLOG(R)
				UCBL(I,J)=UCBL(I,J)+PR*WG(K)*AL/2.
			ENDDO
		ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE LINELOADIN(XLL,YLL,JL,KL,NLL,NELL,FLL,XIN,YIN,IN,P1,
	1          PX,PY,PXX,PYY,PXY,LPX,LPY)
C
C  This subroutine computes line integrals for the line loads when 
C  the source	point is in the interior of the domain  
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XIN(IN),YIN(IN)
	DIMENSION XLL(NLL+NELL),YLL(NLL+NELL),JL(NELL),KL(NELL),FLL(NELL)
	DIMENSION UL(IN,NELL),P1(IN)
 	DIMENSION ULX(IN,NELL),PX(IN)
	DIMENSION ULY(IN,NELL),PY(IN)
	DIMENSION ULXX(IN,NELL),PXX(IN)
	DIMENSION ULYY(IN,NELL),PYY(IN)
	DIMENSION ULXY(IN,NELL),PXY(IN)
	REAL*8    LULX(IN,NELL),LULY(IN,NELL),LPX(IN),LPY(IN)

	CALL UINDERLMATR(XIN,YIN,IN,XLL,YLL,JL,KL,NLL
	#  ,NL,UL,ULX,ULY,ULXX,ULYY,ULXY,LULX,LULY)
	
      DO I=1,IN
	  DO J=1,NELL
	    P1(I)=P1(I)+FLL(J)*UL(I,J)
	    PX(I)=PX(I)+FLL(J)*ULX(I,J)
	    PY(I)=PY(I)+FLL(J)*ULY(I,J)
	    PXX(I)=PXX(I)+FLL(J)*ULXX(I,J)
	    PYY(I)=PYY(I)+FLL(J)*ULYY(I,J)
	    PXY(I)=PXY(I)+FLL(J)*ULXY(I,J)
	    LPX(I)=LPX(I)+FLL(J)*LULX(I,J)
	    LPY(I)=LPY(I)+FLL(J)*LULY(I,J)
	  ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE UINDERLMATR(XIN,YIN,IN,XLL,YLL,JL,KL,NLL
	#  ,NL,UL,ULX,ULY,ULXX,ULYY,ULXY,LULX,LULY)
C
C  This subroutine computes the line integrals for the line loads/supports 
C  in Eq. 2.119 and its derivstives when the source point is in the interior 
C  of the plate

	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XIN(IN),YIN(IN),XLL(NL+NLL),YLL(NL+NLL),JL(NL),KL(NL)
	DIMENSION UL(IN,NL),ULX(IN,NL),ULY(IN,NL)
	DIMENSION ULXX(IN,NL),ULYY(IN,NL),ULXY(IN,NL)
	REAL*8 LULX(IN,NL),LULY(IN,NL)


      COMMON D,PN
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)
	UL=0.
	ULX=0.
	ULY=0.
	ULXX=0.
	ULYY=0.
	ULXY=0.
	LULX=0.
	LULY=0.
      DO I=1,IN
		X0=XIN(I)
		Y0=YIN(I)
		DO J=1,NL
			X1=XLL(JL(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
			Y1=YLL(JL(J))
			X2=XLL(KL(J))
			Y2=YLL(KL(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
	  	AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
C
C	 Compute the line integral with 4 point Gauss integration 
C
			DO K=1,4
				XC=0.
				YC=0.
				XC=AX*XI(K)+BX
				YC=AY*XI(K)+BY
				R=0.
				R=SQRT((X0-XC)**2+(Y0-YC)**2)
				DX=XC-X0
				DY=YC-Y0
				COSA=DX/R
				SINA=DY/R
				RX=(X0-XC)/R
 				RY=(Y0-YC)/R
				PR=0.
 				PR=1./8./PI/D*R**2*DLOG(R)
				UL(I,J)=UL(I,J)+PR*WG(K)*AL/2.
C
C       1st derivatives 
C
				PR=0.
				PR=1./8.*R*RX*(2.*DLOG(R)+1.)/Pi/D
				ULX(I,J)=ULX(I,J)+PR*WG(K)*AL/2.
				PR=0.
				PR=1./8.*R*RY*(2.*DLOG(R)+1.)/Pi/D
				ULY(I,J)=ULY(I,J)+PR*WG(K)*AL/2.
C
C       2nd derivatives 
C
				PR=0.
				PR=1./8./PI/D*(2.*RX**2*DLOG(R)+3.*RX**2
	1					+2.*DLOG(R)*RY**2+RY**2)
	  		ULXX(I,J)=ULXX(I,J)+PR*WG(K)*AL/2.
				PR=0.
				PR=1./8./PI/D*(2.*RY**2*DLOG(R)+3.*RY**2
	1					+2.*DLOG(R)*RX**2+RX**2)
				ULYY(I,J)=ULYY(I,J)+PR*WG(K)*AL/2.
				PR=0.
				PR=1./4.*RX*RY/Pi/D
				ULXY(I,J)=ULXY(I,J)+PR*WG(K)*AL/2.
C
C       3rd derivatives 
C
				PR=0.
  				PR=1./2./PI/D*RX/R
				LULX(I,J)=LULX(I,J)+PR*WG(K)*AL/2.
				PR=0.
  				PR=1./2./PI/D*RY/R
				LULY(I,J)=LULY(I,J)+PR*WG(K)*AL/2.
			ENDDO
		ENDDO
	ENDDO

	DO I=1,IN
		DO J=1,NL
			X1=XLL(JL(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
 			Y1=YLL(JL(J))
			X2=XLL(KL(J))
			Y2=YLL(KL(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
			ENX=2.*AY/AL
			ENY=-2.*AX/AL
			RDIS=DSQRT((XIN(I)-BX)**2+(YIN(I)-BY)**2)
	  	IF (RDIS.LT.0.00001) THEN
				ULXX(I,J)=(2.*(DLOG(AL/2.)-1.)+(2*ENy**2+1.))
	1    		*Al/8./PI/D
				ULYY(I,J)=(2.*(DLOG(AL/2.)-1.)+(2*ENx**2+1.))
	1				*Al/8./PI/D				
			ENDIF
	  ENDDO
	ENDDO


	RETURN
	END
C
C====================================================================
C
	SUBROUTINE UINLMATR(XSL,YSL,JLS,KLS,NELS,NLS,XTM,YTM,NT,USS)
	IMPLICIT REAL*8 (A-H,O-Z)  
	COMMON D,PN
C
C This subroutine computes line integrals for line loads/supports
C
	DIMENSION XSL(NELS+NLS),YSL(NELS+NLS),JLS(NELS)
	DIMENSION KLS(NELS),USS(NT,NELS),XTM(NT),YTM(NT)
	DIMENSION XI(4),WG(4)
	DATA XI/-0.86113631,-0.33998104,0.33998104,0.86113631/
	DATA WG/0.34785485,0.65214515,0.65214515,0.34785485/

	PI=ACOS(-1.)
	USS=0.
      DO I=1,NT
		X0=XTM(I)
		Y0=YTM(I)
		DO J=1,NELS
			X1=XSL(JLS(J))                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
	  	Y1=YSL(JLS(J))
			X2=XSL(KLS(J))
			Y2=YSL(KLS(J))
			AX=(X2-X1)/2.
			AY=(Y2-Y1)/2.
			BX=(X2+X1)/2.
			BY=(Y2+Y1)/2.
			AL=SQRT((X1-X2)**2+(Y1-Y2)**2)
C
C	 Compute the line integral with 4 point Gauss integration 
C
			DO K=1,4
	  		XC=0.
				YC=0.
				XC=AX*XI(K)+BX
				YC=AY*XI(K)+BY
				R=0.
				R=SQRT((X0-XC)**2+(Y0-YC)**2)
				PR=0.
				PR=1./8./PI/D*R**2*DLOG(R)
				USS(I,J)=USS(I,J)+PR*WG(K)*AL/2.
			ENDDO
	  ENDDO
	ENDDO

	RETURN
	END

C
C====================================================================
C
	SUBROUTINE UBPMATR(XL,YL,XM,YM,JN,KN,N,XC,YC,NC,XLL,YLL,NL
 	1                   ,UBP,U1BP,UCBP,LUBP)
C
C  This subroutine computes the vectors of the point loads for the
C  boundary integral equations
C 
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N),XC(NC),YC(NC)
	DIMENSION XLL(NL),YLL(NL),UBP(N,NL),U1BP(N,NL),UCBP(NC,NL)
	REAL*8    LUBP(N,NL)

	COMMON D,PN

	PI=ACOS(-1.)
	UBP=0.
	U1BP=0.
	UCBP=0.

      DO I=1,N
		X0=XM(I)
		Y0=YM(I)
		XA1=XL(JN(I))
 		YA1=YL(JN(I))
		XA2=XL(KN(I))
		YA2=YL(KN(I))
		AAL=SQRT((XA1-XA2)**2+(YA1-YA2)**2)
		AAX=(XA2-XA1)/2.
 		AAY=(YA2-YA1)/2.
		ENAX=2.*AAY/AAL
 		ENAY=-2.*AAX/AAL
		DO J=1,NL
			BX=XLL(J)
			BY=YLL(J)
			R=0.
			R=(X0-BX)**2+(Y0-BY)**2
			IF (ABS(R).LT.0.00001) THEN
				UBP(I,J)=0.
				U1BP(I,J)=0.
				LUBP(I,J)=0. 
			ELSE
				R=SQRT(R)
				DX=BX-X0
				DY=BY-Y0
				COSA=DX/R
				SINA=DY/R
				RAN=-COSA*ENAX-SINA*ENAY
				UBP(I,J)=1/8./PI/D*R**2*DLOG(R)
				U1BP(I,J)=1./8./PI/D*R*RAN*(2*DLOG(R)+1.)
				LUBP(I,J)=1./2./PI/D*(DLOG(R)+1.)
			ENDIF
		ENDDO
	ENDDO

	DO I=1,NC
		X0=XC(I)
		Y0=YC(I)
		DO J=1,NL
			BX=XLL(J)
			BY=YLL(J)
			R=0.
			R=(X0-BX)**2+(Y0-BY)**2
	  	IF (ABS(R).LT.0.00001) THEN
				UCBP(I,J)=0.
			ELSE
				R=SQRT(R)
				UCBP(I,J)=1/8./PI/D*R**2*DLOG(R)
     			ENDIF
		ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C

	SUBROUTINE UINPMATR(XPS,YPS,NPS,XTM,YTM,NT,USS)
C
C   This subroutine computes the vector of the point loads/supports 
C   for boundary integral equations 
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XPS(NPS),YPS(NPS),USS(NT,NPS),XTM(NT),YTM(NT)
	COMMON D,PN

	PI=ACOS(-1.)
	USS=0.
      DO I=1,NT
		X0=XTM(I)
		Y0=YTM(I)
		DO J=1,NPS
			X1=XPS(J)
	  	Y1=YPS(J)
	    R=0.
			R=(X0-X1)**2+(Y0-Y1)**2
			IF (ABS(R).LT.0.00001) then
				USS(I,J)=0.
			ELSE
				R=SQRT(R)
			  USS(I,J)=1/8./PI/D*R**2*DLOG(R)
			ENDIF
	  ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C

	SUBROUTINE UINDERPMATRIN(XPS,YPS,NPS,XTM,YTM,NT
	&  ,UP,UPX,UPY,UPXX,UPYY,UPXY,LUPX,LUPY)
C
C   This subroutine computes the vectors for point loads/supports
C   for Eq. 2.119 and its derivatives when the source point is 
C   at the interior point
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XPS(NPS),YPS(NPS),XTM(NT),YTM(NT)
	DIMENSION UP(NT,NPS),UPX(NT,NPS),UPY(NT,NPS),UPXX(NT,NPS)
	DIMENSION UPYY(NT,NPS),UPXY(NT,NPS)
	REAL*8    LUPX(NT,NPS),LUPY(NT,NPS)
	COMMON D,PN

	UP=0.
 	UPX=0.
	UPY=0.
	UPXX=0.
	UPYY=0.
	UPXY=0.
	LUPX=0.
	LUPY=0.
	PI=ACOS(-1.)
      DO I=1,NT
		X0=XTM(I)
		Y0=YTM(I)
		DO J=1,NPS
			X1=XPS(J)
	  	Y1=YPS(J)
			DIS=DSQRT((X0-X1)**2+(Y0-Y1)**2)
			IF (DIS.LT.0.00001) THEN
				UP(I,J)=0.
				UPX(I,J)=0.
				UPY(I,J)=0.
	   		WRITE (*,*) ' INTERNAL POINT:',I,' IS LOCATED AT POINT LOAD'
			ELSE 
				R=0.
				R=SQRT((X0-X1)**2+(Y0-Y1)**2)
	  		UP(I,J)=1/8./PI/D*R**2*DLOG(R)
				RX=-(X1-X0)/R
   				RY=-(Y1-Y0)/R
				UPX(I,J)=1./8.*R*RX*(2.*dlog(R)+1.)/Pi/D
 				UPY(I,J)=1./8.*R*RY*(2.*DLOG(R)+1.)/Pi/D
				UPXX(I,J)=1./8./PI/D*(2.*RX**2*DLOG(R)+3.*RX**2
	1			  +2.*DLOG(R)*RY**2  +RY**2)
				UPYY(I,J)=1./8./PI/D*(2.*RY**2*DLOG(R)+3.*RY**2
	1	      +2.*DLOG(R)*RX**2+RX**2) 
				UPXY(I,J)=1./4.*RX*RY/Pi/D
				LUPX(I,J)=1./2./PI/D*RX/R
	  		LUPY(I,J)=1./2./PI/D*RY/R
			ENDIF
	  ENDDO
	ENDDO

	RETURN
	END
C
C====================================================================
C
	SUBROUTINE FLOADPOINT(XCN,YCN,NCL,FC,XL,YL,XM,YM,JN,KN,
	1           XC,YC,N,NC,NELS,XSM,YSM,NPS,XPS,YPS,FLOAD,FLOADL)
C
C  This subroutine computes the vectors for point loads for the
C  boundary integral equations Eq. 2.93, 2.118 
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XL(N),YL(N),XM(N),YM(N),JN(N),KN(N)
	DIMENSION XC(NC),YC(NC),XSM(NELS),YSM(NELS),XPS(NPS),YPS(NPS)
	DIMENSION XCN(NCL),YCN(NCL),FC(NCL)
      DIMENSION UBP(N,NCL),U1BP(N,NCL),UCBP(N,NCL)
	REAL*8    LUBP(N,NCL)
	DIMENSION UP1(NELS,NCL),UP2(NPS,NCL)
	DIMENSION P1(N),P2(N),P3(NC),P4(N),P5(NELS),P6(NPS)
	DIMENSION FLOAD(2*N+NC+NELS+NPS),FLOADL(2*N+NC)

	CALL UINPMATR(XCN,YCN,NCL,XSM,YSM,NELS,UP1)
	CALL UINPMATR(XCN,YCN,NCL,XPS,YPS,NPS,UP2)
	CALL UBPMATR(XL,YL,XM,YM,JN,KN,N,XC,YC,NC,XCN,YCN,NCL
 	1                   ,UBP,U1BP,UCBP,LUBP)

	P1=0.
	P2=0.
	P3=0.
	P4=0.
	P5=0.
 	P6=0.
	DO J=1,NCL
		DO I=1,N
			P1(I)=P1(I)+UBP(I,J)*FC(J)
			P2(I)=P2(I)+U1BP(I,J)*FC(J)
			P4(I)=P4(I)+LUBP(I,J)*FC(J)
	    ENDDO
		DO I=1,NC
			P3(I)=P3(I)+UCBP(I,J)*FC(J)
		ENDDO
		DO I=1,NELS
			P5(I)=P5(I)+UP1(I,J)*FC(J)
		ENDDO
	 	DO I=1,NPS
			P6(I)=P6(I)+UP2(I,J)*FC(J)
		ENDDO
      ENDDO
	
      DO I=1,N
		FLOAD(I)=FLOAD(I)+P1(I)
		FLOADL(I)=FLOADL(I)+P1(I)
		FLOADL(I+N)=FLOADL(I+N)+P4(I)
		FLOAD(I+N+NC)=FLOAD(I+N+NC)+P2(I)
	ENDDO
	
      DO I=1,NC
		FLOAD(I+N)=FLOAD(I+N)+P3(I)
	ENDDO
      DO I=1,NELS
		FLOAD(I+2*N+NC)=FLOAD(I+2*N+NC)+P5(I)
	ENDDO
      DO I=1,NPS
		FLOAD(I+2*N+NC+NELS)=FLOAD(I+2*N+NC+NELS)+P6(I)
	ENDDO

	RETURN
	END

C
C====================================================================
C
	SUBROUTINE POINTLOADIN(XCL,YCL,NCL,FCL,XIN,YIN,IN,P1,
	1         PX,PY,PXX,PYY,PXY,LPX,LPY)
C
C  This subroutine computes the vectors for point loads for Eq. 2.119 and
C  its derivatives when the source point is in the interior of the domain  
C
	IMPLICIT REAL*8 (A-H,O-Z)  
	DIMENSION XIN(IN),YIN(IN)
	DIMENSION XCL(NCL),YCL(NCL),FCL(NCL)
	DIMENSION UP(IN,NCL),P1(IN)
 	DIMENSION UPX(IN,NCL),PX(IN)
	DIMENSION UPY(IN,NCL),PY(IN)
	DIMENSION UPXX(IN,NCL),PXX(IN)
	DIMENSION UPYY(IN,NCL),PYY(IN)
	DIMENSION UPXY(IN,NCL),PXY(IN)
	REAL*8 LUPX(IN,NCL),LUPY(IN,NCL),LPX(IN),LPY(IN)

 	CALL UINDERPMATRIN(XCL,YCL,NCL,XIN,YIN,IN,UP,UPX,UPY,UPXX,UPYY
	1      ,UPXY,LUPX,LUPY) 
      DO I=1,IN
	  DO J=1,NCL
	    P1(I)=P1(I)+FCL(J)*UP(I,J)
	    PX(I)=PX(I)+FCL(J)*UPX(I,J)
	    PY(I)=PY(I)+FCL(J)*UPY(I,J)
	    PXX(I)=PXX(I)+FCL(J)*UPXX(I,J)
	    PYY(I)=PYY(I)+FCL(J)*UPYY(I,J)
	    PXY(I)=PXY(I)+FCL(J)*UPXY(I,J)
	    LPX(I)=LPX(I)+FCL(J)*LUPX(I,J)
	    LPY(I)=LPY(I)+FCL(J)*LUPY(I,J)
	  ENDDO
	ENDDO


	RETURN
	END

C
C====================================================================
C

      SUBROUTINE OUTPUTPL(XM,YM,W,WN,XC,YC,WCORN,FCORN,VN,MN,XIN,YIN
     1      ,WIN,WX,WY,MX,MY,MXY,QX,QY,N,IN,NC,SL,XSM,YSM,NELS
     1       ,SP,XPS,YPS,NPS)
C
C  This subroutine prints the results in the outputfile.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XM(N),YM(N),XIN(N),YIN(N),WX(IN),WY(IN)
	DIMENSION WIN(IN),QX(IN),QY(IN),W(N),VN(N),WN(N)
	DIMENSION XC(NC),YC(NC),FCORN(NC),WCORN(NC)
	REAL*8    MX(IN),MY(IN),MXY(IN),MN(N)
	DIMENSION XSM(NELS),YSM(NELS),SL(NELS),XPS(NPS),YPS(NPS),SP(NPS)


C
      WRITE(2,10)
   10 FORMAT('',76('*')///'RESULTS'///2X,'BOUNDARY NODES'//'NODE',
     1         5X,'X',11X,'Y',12X,'W',11X,'Wn',10X,'Vn',9X,'Mn'/)
      DO I=1,N
					WRITE(2,50)I,XM(I),YM(I),W(I),WN(I),VN(I),MN(I)
	ENDDO

   50 FORMAT(I5,2(1X,E11.5),1X,4(1X,E11.5))

      WRITE(2,100)
  100 FORMAT(//2X,'CORNER POINTS'//'CORNER',
     1         5X,'XC',11X,'YC',12X,'WC',11X,'R',/)
      DO I=1,NC
					WRITE(2,150)I,XC(I),YC(I),WCORN(I),FCORN(I)
	ENDDO
  150 FORMAT(I3,4(2X,E11.5))


	IF (NELS.GT.0) THEN
      WRITE(2,200)
  200 FORMAT(//' LINE SUPPORTS REACTIONS'//'NODE',
     1         7X,'X',16X,'Y',15X,'SL'/)
      DO I=1,NELS
					WRITE(2,250)I,XSM(I),YSM(I),SL(I)
	ENDDO
  250 FORMAT(I3,3(2X,E14.5))
	ENDIF

	IF (NPS.GT.0) THEN
      WRITE(2,300)
  300 FORMAT(//' POINT SUPPORTS REACTIONS '//'NODE',
     1         5X,'X',15X,'Y',15X,'SP'/)
      DO I=1,NPS
					WRITE(2,350)I,XPS(I),YPS(I),SP(I)
	ENDDO
  350 FORMAT(I3,3(2X,E14.5))
	ENDIF
C

      WRITE (2,400)
  400 FORMAT(//,2X,'DISPLACEMENTS AND SLOPES AT INTERNAL POINTS'
	1				//'  POINT',9X,'X',14X,'Y',15X,'W',15X,'Wx',15X,'Wy'/)
      DO I=1,IN
					WRITE(2,500)I,XIN(I),YIN(I),WIN(I),WX(I),WY(I)
	ENDDO
  500 FORMAT(I5,5(2X,E14.5))


      WRITE(2,600)
  600 FORMAT(//,2X,'BENDING MOMENTS AT THE INTERNAL POINTS'/)
      WRITE (2,700)
  700 FORMAT('   NODE',7X,'X',15X,'Y',15X,'Mx',15X,'My',15X,'Mxy'/)
      DO I=1,IN
					WRITE(2,500)I,XIN(I),YIN(I),MX(I),MY(I),MXY(I)
	ENDDO

      WRITE(2,800)
  800 FORMAT(//,2X,'SHEAR FORCES AT THE INTERNAL POINTS'/)
      WRITE (2,900)
  900 FORMAT('   NODE',7X,'X',15X,'Y',15X,'Qx',15X,'Qy',/)
      DO I=1,IN
					WRITE(2,1000)I,XIN(I),YIN(I),QX(I),QY(I)
	ENDDO
 1000 FORMAT(I5,4(2X,E14.5))

      WRITE(2,1100)
 1100 FORMAT(/,'',76('*'))
 	CLOSE (2)

      RETURN
      END
C
C==================================================================

