function [m,xin,yin]=checkin(nb,mt,xb,yb,xint,yint,cn,sn,length,dist)
%
% Function CHECKIN evaluates:
%    The coordinates of the xin, yin of the points inside the domain
%    xin  : x coordinate of domain nodal point
%    yin  : y coordinate of domain nodal point
%    m    : total number of points inside the domain of the plate

%==========================================================================
% The line integral e=int(rn/(2*p*r) on boundary is evaluated. 
% If e=1, point lies inside the domain
%==========================================================================
unit=ones(1,nb);
for i=1:mt
    for j=1:nb
        r=sqrt((xb(j)-xint(i))^2+(yb(j)-yint(i))^2);
        rx=(xb(j)-xint(i))/r;
        ry=(yb(j)-yint(i))/r;
        rn=rx*cn(j)+ry*sn(j);
        H(i,j)=rn/(2*pi*r)*length(j);
    end
end
e=H*unit';
icount =0;
r=zeros(mt,nb);
for i=1:mt
    for j=1:nb
        r(i,j)= sqrt((xb(j)-xint(i))^2+(yb(j)-yint(i))^2);
    end
end
for ii=1:mt
    if abs(abs(e(ii))-1)<0.1
%==========================================================================
% Exclude internal points at a distance less than "dist" from the boundary 
%==========================================================================
        [code]=checkdist(nb,xb,yb,xint(ii),yint(ii),dist);
        if (code==1)   
        icount=icount+1;
        xin(icount)=xint(ii);
        yin(icount)=yint(ii);
        end
    end        
end
m=icount;  
