function [xl,yl,cur]=circle(x0,y0,phi1,phi2,R,ne)
%
%Function CIRCLE evaluates:
%    The coordinates of the end points of the constant
%    elements on circular arc an
%    xl  : x coordinate of the end points of the boundary elements
%    yl  : y coordinate of the end points of the boundary elements
%    cur : curvature of the boundary 

xl=zeros(ne,1);
yl=zeros(ne,1);
cur=zeros(ne,1);

phi=phi2-phi1;   % span of the arc
dphi=phi/ne;     % number of circular arcs
t=phi1:dphi:phi2;
r=R;             % radius of arc
[x,y]=pol2cart(t,r);
for ii=1:ne
    xl(ii)=x(ii)+x0;
    yl(ii)=y(ii)+y0;
    % evaluate curvature
    if phi > 0
        cur(ii)=1/R;
    else
        cur(ii)=-1/R;
    end
end




