function [xint,yint,mt]=meshpoints(nrow,ncol,xl,yl)
%
%Function MESHPOINTS evaluates :
% A rectangular mesh with nrow X ncol nodal points is applied on the
% domain of the  plate. The coordinates of the nodal points are xint,yint

mt=nrow*ncol;
xint=zeros(1,mt);
yint=zeros(1,mt);
ax=max(xl)-min(xl);
by=max(yl)-min(yl);
dxin=ax/(ncol+1);
dyin=by/(nrow+1); 
for i=1:nrow
    for j=1:ncol
        k=(i-1)*ncol+j;
       xint(k)=min(xl)+j*dxin;
       yint(k)=min(yl)+i*dyin;
    end
end
